%*************************************************************
%*  Ing. OLDICH EVEEK v rmci projetku FRV 2421/2007/G1 *
%*************************************************************

clear all,

poradidelta=1;  %toto je promenna, ktera udava, ktere delta uvazujeme (1 - uvazujeme delta z intervalu(0,1) 

%Tento soubor nacte hodnoty z ansysu, vypocita hodnoty pomocneho reseni
%pomoci m-filu singularsol (pro prislusne uhly odpovidajici uhlum nodu z ansysu a nasledne tyto dve hodnoty spolu pro integruje
%na integracni ceste RC2
%*************************************************************************
%******* I N P U T   O B L A S T *****************************************
%*************************************************************************
%POZN: integracni polomer se nacita primo z txt souboru ansysu - je tam
%ulozenen ve sloupci SOURR-4. sloupec. - viz radek 37 (hodnoty v metrech)

alfa=0;      %uhel trhliny od zaporne osy X

cesta = ('VYPOCTY\');

%*********************************************************************************
%***** N A C T E  S E   S O U B O R   Z   M K P  S    D A T Y  O  U Z L E C H ****
%*********************************************************************************
filename=['posuvy_a_napeti_na_ceste_C2','.txt'];
%%'_opacnematerialy',
%filename2=['hodnoty_uzlu_proALFA=',num2str(alfa),'.txt'];  %'_opacnematerialy',
f2 = fullfile(cesta, filename)  %prikaz ktery vytvori komplet cestu k danemu souboru
fid=fopen(f2,'r');   %fid=fopen(f2,'r');
%nacteme prvni serii dat (mezi prvni a druhou hlavickou)  
C = textscan(fid, '%f %f %f %f %f %f %f %f %f %f %f ', 'headerlines', 1)  %37 znamena kolik radku se ma cist, 11 znamena kolik radku vynechat
%'SOURFItr','SOURX','SOURY','SOURR','SOURFI','POSUVXre','POSUVYre','OBLAST','NAPX','NAPY','NAPXY'
fclose(fid)                      %uzavre soubor pro cteni
uzly = cell2mat(C);              %cell2mat (prevede CELL na obycejnou matici)
uzly_sort = sortrows(uzly,[8,1]);    %nejdrve se seradi podle 11.sloupecku - OBLAST a pak podle uhlu - pocatek na dolnim cele trhliny - sloupecek 12

[k,r] = size(uzly);                  %k - pocet radku , r - pocet sloupcu
%*************ZDE SE NACTE INTEGRACNI POLOMER - ze souboru UZLY *****
RC2 =uzly(1,4) * 10^-3;    %ve ctvrtem sloupci jsou hodnoty polomeru integracni cesty - nasobime jeste 10^-3 - prevedeme na metry
%********************************************************************

B=uzly_sort;   %pro jednodussi zapis se matice uzly_sort zapise jako B
%MATICE B - CO OBSAHUJE:

%******Do promenne Bsel  ulozime pouze hodnoty ktere budeme nutne
%potrebovat do vypoctu Psi integralu (k integraci)************************
Bsel = zeros(k,12);              %vytvori prazdnou matici k*12
 Bsel(:,1) = B(:,1);             %do 1. sloupecku ulozime uhel ve stupnich 0-360
 Bsel(:,2) = Bsel(:,1)* pi/180;  %do 2. sloupecku ulozime uhel v radianech 0-2pi
 Bsel(:,3) = 10^-3*B(:,6);       %do 3 sloupecku se ulozi UX z MKP (m) %10^3 prevede mm z ansysu na metry
 Bsel(:,4) = 10^-3*B(:,7);       %do 4. sloupecku se ulozi UY z MKP (m)%10^3 prevede mm z ansysu na metry
 Bsel(:,5) = B(:,9);             %do 5. sloupecku se ulozi SX z MKP (MPa)
 Bsel(:,6) = B(:,10);            %do 6. sloupecku se ulozi SY z MKP (MPa)
 Bsel(:,7) = B(:,11);            %do 7. sloupecku se ulozi SXY z MKP (MPa)

 Bsel(:,28) = B(:,8);            %do 28. sloupecku se ulozi oblast daneho nodu
 %v nasledujicim cyklu se do sloupce 8-12 pomoc funkce singularsol vypoctou
%pro prislusne uhly hodnoty UXpom,UYpom,SXpom,SYpom,SXYpom - pomocne reseni
for t=1:k,
uheltheta=Bsel(t,1);  %zde se v tomto cyklu vypoctou hodnoty pomocneho reseni na polomeru RC2
 [UXpom,UYpom,SXpom,SYpom,SXYpom] = SingularSolution(uheltheta,RC2,1,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC2; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,8)  = UXpom;   %do 8. sloupecku se ulozi UX pomocneho reseni (m)
  Bsel(t,9)  = UYpom;   %do 9. sloupecku se ulozi UY pomocneho reseni (m)
  Bsel(t,10) = SXpom;   %do 10. sloupecku se ulozi SX pomocneho reseni (MPa)
  Bsel(t,11) = SYpom;   %do 11. sloupecku se ulozi SY pomocneho reseni (MPa)
  Bsel(t,12) = SXYpom;  %do 12. sloupecku se ulozi SXY pomocneho reseni (MPa)
end;
for t=1:k,
uheltheta=Bsel(t,1);  %zde se v tomto cyklu vypoctou hodnoty singularniho reseni na polomeru 1
  [UXsin,UYsin,SXsin,SYsin,SXYsin] = SingularSolution(uheltheta,1,2,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,13) = UXsin;  %do 13. sloupecku se ulozi UX singularniho reseni (MPa)
  Bsel(t,14) = UYsin;  %do 14. sloupecku se ulozi UY singularniho reseni (MPa)
  Bsel(t,15) = SXsin;  %do 15. sloupecku se ulozi SX singularniho reseni (MPa)
  Bsel(t,16) = SYsin;  %do 16. sloupecku se ulozi SY singularniho reseni (MPa)
  Bsel(t,17) = SXYsin;  %do 17. sloupecku se ulozi SXY singularniho reseni (MPa)
end;
for t=1:k,
uheltheta=Bsel(t,1);  %zde se v tomto cyklu vypoctou hodnoty pomocneho reseni na polomeru 1
 [UXpom,UYpom,SXpom,SYpom,SXYpom] = SingularSolution(uheltheta,1,1,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC2; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,18)  = UXpom;   %do 8. sloupecku se ulozi UX pomocneho reseni (m)
  Bsel(t,19)  = UYpom;   %do 9. sloupecku se ulozi UY pomocneho reseni (m)
  Bsel(t,20) = SXpom;   %do 10. sloupecku se ulozi SX pomocneho reseni (MPa)
  Bsel(t,21) = SYpom;   %do 11. sloupecku se ulozi SY pomocneho reseni (MPa)
  Bsel(t,22) = SXYpom;  %do 12. sloupecku se ulozi SXY pomocneho reseni (MPa)
end;

for t=1:k,
uheltheta=Bsel(t,1);  %zde se v tomto cyklu vypoctou hodnoty singularniho reseni na polomeru RC2 - budeme potrebovat pro vykreseleni a porovnani hodnot z MKP a anylytickho resen
  [UXsin,UYsin,SXsin,SYsin,SXYsin] = SingularSolution(uheltheta,RC2,2,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,23) = UXsin;  %do 13. sloupecku se ulozi UX singularniho reseni (MPa)
  Bsel(t,24) = UYsin;  %do 14. sloupecku se ulozi UY singularniho reseni (MPa)
  Bsel(t,25) = SXsin;  %do 15. sloupecku se ulozi SX singularniho reseni (MPa)
  Bsel(t,26) = SYsin;  %do 16. sloupecku se ulozi SY singularniho reseni (MPa)
  Bsel(t,27) = SXYsin;  %do 17. sloupecku se ulozi SXY singularniho reseni (MPa)
end;
%***** PLOT HODNOT Z MATICE Bsel - MKP RESENI **************
figure(5),
subplot(2,3,1); plot(Bsel(:,1), Bsel(:,3)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny MKP - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_x (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
subplot(2,3,2); plot(Bsel(:,1), Bsel(:,4)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_y (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,3); plot(Bsel(:,1), Bsel(:,5)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny MKP - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_x (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,4); plot(Bsel(:,1), Bsel(:,6)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny MKP - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_y_y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,5); plot(Bsel(:,1), Bsel(:,7)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny  MKP- []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title('RESENI Z MKP','FontName','times','FontSize',14,'FontWeight','bold'), 


%***** PLOT HODNOT Z MATICE Bsel -pomocne reseni (singul.res)**************
figure(6),
subplot(2,3,1); plot(Bsel(:,1), Bsel(:,8)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_x'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
subplot(2,3,2); plot(Bsel(:,1), Bsel(:,9)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_y'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,3); plot(Bsel(:,1), Bsel(:,10)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_x'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,4); plot(Bsel(:,1), Bsel(:,11)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_y_y'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,5); plot(Bsel(:,1), Bsel(:,12)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_y'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
 title('Pomocne reseni','FontName','times','FontSize',14,'FontWeight','bold'), 

 %***** PLOT HODNOT Z MATICE Bsel -Singularni reseni **************
figure(7),
subplot(2,3,1); plot(Bsel(:,1), Bsel(:,13)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_x (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
subplot(2,3,2); plot(Bsel(:,1), Bsel(:,14)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_y (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,3); plot(Bsel(:,1), Bsel(:,15)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_x (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,4); plot(Bsel(:,1), Bsel(:,16)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_y_y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,5); plot(Bsel(:,1), Bsel(:,17)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
 title('Singularni reseni','FontName','times','FontSize',14,'FontWeight','bold'), 

%Nyni vytvorime tabulku hodnot, ktere nasledovne pouzijem pro integraci
%******** TABULKA_PRO_INTEGRACI ***************************************

tabulka_pro_integraci=zeros(k,8);   %vytvori se prazdna matice o osmi sloupcich a poctu radku k - pocet zaznamu z MKP

tabulka_pro_integraci(:,1)=Bsel(:,1);     %1. sloupec v matici tabulka_pro_integraci budou uhly nodu 'SOURFI 0-360-pocatekVtrhline
tabulka_pro_integraci(:,2)=Bsel(:,2);     %2. sloupec budou hodnoty sloupce 1. ale v RADIANECH

%Nyn budeme pocitat nasledujici vyraz pro jednotlive uzly a vse ukladat do
%tabulky pro integraci
%S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b

%VEKTOR vnejsi normaly je pro SS maplu ( cos(theta + natoceni), sin(theta + natoceni))
   
nat= -pi/2;   %natoceni trhliny vi kladn ose X (osa X smeruje v ansysu o 90 stupnu pootocena k trhline)

%zde se ulozi hodnoty pro integracni cestu C2=R
for j=1:k  %POZN: a - reseni MKP, b - pomocne reseni - na integracni ceste C2
%                               S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b
    tabulka_pro_integraci(j,3)=( Bsel(j,5)*cos(Bsel(j,2)+nat)*Bsel(j,8))+(Bsel(j,7) *sin(Bsel(j,2)+nat) *  Bsel(j,8))+(Bsel(j,7) *cos(Bsel(j,2)+nat)* Bsel(j,9))+(Bsel(j,6) * sin(Bsel(j,2)+nat)* Bsel(j,9));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXa     *      n1       *    UXb  )+(    SXYa  *       n2       *      UXb  )+(    SYXa  *        n1     *     UYb  )+(    SYa   *        n2     *    UYb   )                *  
    tabulka_pro_integraci(j,4)=(Bsel(j,10)*cos(Bsel(j,2)+nat)*Bsel(j,3))+(Bsel(j,12)*sin(Bsel(j,2)+nat) *  Bsel(j,3))+(Bsel(j,12)*cos(Bsel(j,2)+nat)* Bsel(j,4))+(Bsel(j,11)* sin(Bsel(j,2)+nat)* Bsel(j,4));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXb     *      n1       *    UXa  )+(    SXYb  *       n2       *      UXa  )+(    SYXb  *        n1     *     UYa  )+(    SYb   *        n2     *    UYa   )                *  

  tabulka_pro_integraci(j,5)=tabulka_pro_integraci(j,3)-tabulka_pro_integraci(j,4);
end;
%zde se ulozi hodnoty pro integracni cestu C1=0
for j=1:k  %POZN: a - singularni reseni, b - pomocne reseni - na integracni ceste C1
%                               S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b
    tabulka_pro_integraci(j,6)=( Bsel(j,15)*cos(Bsel(j,2)+nat)*Bsel(j,18))+(Bsel(j,17) *sin(Bsel(j,2)+nat) *  Bsel(j,18))+(Bsel(j,17) *cos(Bsel(j,2)+nat)* Bsel(j,19))+(Bsel(j,16) * sin(Bsel(j,2)+nat)* Bsel(j,19));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXa      *      n1          *    UXb  )+(    SXYa  *       n2          *      UXb  )+(    SYXa    *        n1        *     UYb  )+(    SYa    *        n2         *    UYb   )                *  
    tabulka_pro_integraci(j,7)=(Bsel(j,20)*cos(Bsel(j,2)+nat)*Bsel(j,13))+(Bsel(j,22)*sin(Bsel(j,2)+nat) *  Bsel(j,13))+(Bsel(j,22)*cos(Bsel(j,2)+nat)* Bsel(j,14))+(Bsel(j,21)* sin(Bsel(j,2)+nat)* Bsel(j,14));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXb     *      n1          *    UXa   )+(    SXYb  *       n2          *      UXa  )+(    SYXb   *        n1        *     UYa   )+(   SYb    *        n2         *    UYa   )                *  

  tabulka_pro_integraci(j,8)=tabulka_pro_integraci(j,6)-tabulka_pro_integraci(j,7);
end;

%*********************SLOZENI TABULKY_PRO_INTEGRACI ************************
%SLOUPCE
% 1-uhly ve stupnich v nich je vycislena prislusna velicina 0-360stupnu
% 2-uhly z 1 v radianech 
% 3-soucty prvniho clenu v PSI-integralu (krivka C2) - MKP a POMOCNE
% 4-soucty druheho clenu v PSI-integralu (krivka C2) - MKP a POMOCNE
% 5-rozdil obou hodnoty (3-4)- defakto celkova funkcni hodnota (krivka C2)

% 6-soucty prvniho clenu v PSI-integralu (krivka C1) - SINGULARNI a POMOCNE
% 7-soucty druheho clenu v PSI-integralu (krivka C1) - SINGULARNI a POMOCNE
% 8-rozdil obou hodnoty (6-7)- defakto celkova funkcni hodnota (krivka C1)
%**************************************************************************

figure(8), %vykresli se do grafu 4 funkce kterou vlastne budeme integrovat - cely vnitrek integralu
subplot(2,1,1);
  plot(tabulka_pro_integraci(:,1),tabulka_pro_integraci(:,5),'Color','b','LineWidth',2),hold on; %integrand na ceste R2
  xlim([0 360]);  set(gca,'xtick',[0 45 90 135 180 225 270 315 360]); grid on;
  title('Prubeh integrovane funkce na ceste C2- SS MAPLE','FontName','times','FontSize',14,'FontWeight','bold'), 
  legend('Integracni cesta C2 - r=R',1);
subplot(2,1,2);
  plot(tabulka_pro_integraci(:,1),tabulka_pro_integraci(:,8),'Color','r','LineWidth',2),hold on; %integrand na ceste R1
  xlim([0 360]);  set(gca,'xtick',[0 45 90 135 180 225 270 315 360]); grid on;
  title('Prubeh integrovane funkce na ceste C1 - SS MAPLE','FontName','times','FontSize',14,'FontWeight','bold'), 
  legend('Integracni cesta C1 - r=0',1);

%********************************************************************
%INTEGRACE PODEL KRIVEK C1 a C2 - pouzita bude SIMPSONOVA METODA  ***
%********************************************************************

X = tabulka_pro_integraci; %pro zjednoduseni zapisu v dalsich vypoctech, ulozime "tabulku_pro_integraci" do promenne X

%*********************************************************************************
%*************** I N T E G R A C E   P O   O B L A S T E C H  na C1 **************
%*********************************************************************************
%Zde v nasledujicim  zkusime integraci po castech v kazdem materialu budeme integrovat zvlast- na rozhrani je totiz nespojitost - skokova zmena a ta
%muze pri numericke integraci zpusobovat chybu.

INTBODY_I=0  ; for i=1:length(X), if Bsel(i,28)==1 ; INTBODY_I=INTBODY_I+1;   end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci
INTBODY_II=0 ; for i=1:length(X), if Bsel(i,28)==2 ; INTBODY_II=INTBODY_II+1;  end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci
INTBODY_III=0; for i=1:length(X), if Bsel(i,28)==3 ; INTBODY_III=INTBODY_III+1;end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci
INTBODY_IV=0 ; for i=1:length(X), if Bsel(i,28)==4 ; INTBODY_IV=INTBODY_IV+1;  end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci

PSI_INT_C1pp=zeros(4,1);         %hodnota integralu na krivce C1 - integrovano po castech ("per partes") v oblsti I

%integrace dolni celo az rozhrani (OBLAST I)
pruchodpp(1)=0;
for i=1:2:INTBODY_I-2,   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
    PSI_INT_C1pp(1) = PSI_INT_C1pp(1) + ((X(i+2,2)-X(i,2))/6) * (X(i,8) + 4*X(i+1,8) + X(i+2,8));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
    pruchodpp(1)=pruchodpp(1)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%integrace  rozhrani az 90 stupnu (OBLAST II)
pruchodpp(2)=0 ;
for i=INTBODY_I+1:2:(INTBODY_I+INTBODY_II-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
    PSI_INT_C1pp(2) = PSI_INT_C1pp(2) + ((X(i+2,2)-X(i,2))/6) * (X(i,8) + 4*X(i+1,8) + X(i+2,8));    %Vypocet integralu na krivce C2 (vzdaleny od korene)        pruchodpp(2)=pruchodpp(2)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
    pruchodpp(2)=pruchodpp(2)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%integrace   90 stupnu az rozhrani (OBLAST III)
pruchodpp(3)=0;
for i=(INTBODY_I+INTBODY_II+1):2:(INTBODY_I+INTBODY_II+INTBODY_III-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
   PSI_INT_C1pp(3) = PSI_INT_C1pp(3) + ((X(i+2,2)-X(i,2))/6) * (X(i,8) + 4*X(i+1,8) + X(i+2,8));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(3)=pruchodpp(3)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%integrace   rozhrani az horni celo (OBLAST IV)
pruchodpp(4)=0;
for i=(INTBODY_I+INTBODY_II+INTBODY_III+1):2:(length(X)-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
   PSI_INT_C1pp(4) = PSI_INT_C1pp(4) + ((X(i+2,2)-X(i,2))/6) * (X(i,8) + 4*X(i+1,8) + X(i+2,8));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(4)=pruchodpp(4)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

pruchodpp1 = pruchodpp(1) + pruchodpp(2) + pruchodpp(3) + pruchodpp(4);  %kontrolni promenna
PSI_INT_C1pp_RESULT = PSI_INT_C1pp(1) + PSI_INT_C1pp(2) + PSI_INT_C1pp(3) + PSI_INT_C1pp(4) ; %indexy v zavorkach znamenaji oblast ve ktere se integrovalo (vytvori se vlastne sloupcovy vektor, kde jednotlive radky jsou integrace pres jednotlive oblasti)
 
%*********************************************************************************
%*************** I N T E G R A C E   P O   O B L A S T E C H  na C2 **************
%*********************************************************************************
%Zde v nasledujicim  zkusime integraci po castech v kazdem materialu budeme integrovat zvlast- na rozhrani je totiz nespojitost - skokova zmena a ta
%muze pri numericke integraci zpusobovat chybu.

PSI_INT_C2pp=zeros(4,1);         %hodnota integralu na krivce C1 - integrovano po castech ("per partes") v oblsti I

%integrace dolni celo az rozhrani (OBLAST I)
pruchodpp(1)=0;
for i=1:2:INTBODY_I-2,   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
    PSI_INT_C2pp(1) = PSI_INT_C2pp(1) + RC2*((X(i+2,2)-X(i,2))/6) * (X(i,5) + 4*X(i+1,5) + X(i+2,5));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
    pruchodpp(1)=pruchodpp(1)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%integrace  rozhrani az 90 stupnu (OBLAST II)
pruchodpp(2)=0 ;
for i=INTBODY_I+1:2:(INTBODY_I+INTBODY_II-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
    PSI_INT_C2pp(2) = PSI_INT_C2pp(2) + RC2*((X(i+2,2)-X(i,2))/6) * (X(i,5) + 4*X(i+1,5) + X(i+2,5));    %Vypocet integralu na krivce C2 (vzdaleny od korene)        pruchodpp(2)=pruchodpp(2)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
    pruchodpp(2)=pruchodpp(2)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%integrace   90 stupnu az rozhrani (OBLAST III)
pruchodpp(3)=0;
for i=(INTBODY_I+INTBODY_II+1):2:(INTBODY_I+INTBODY_II+INTBODY_III-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
   PSI_INT_C2pp(3) = PSI_INT_C2pp(3) + RC2*((X(i+2,2)-X(i,2))/6) * (X(i,5) + 4*X(i+1,5) + X(i+2,5));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(3)=pruchodpp(3)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%integrace   rozhrani az horni celo (OBLAST IV)
pruchodpp(4)=0;
for i=(INTBODY_I+INTBODY_II+INTBODY_III+1):2:(length(X)-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
   PSI_INT_C2pp(4) = PSI_INT_C2pp(4) + RC2*((X(i+2,2)-X(i,2))/6) * (X(i,5) + 4*X(i+1,5) + X(i+2,5));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(4)=pruchodpp(4)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

pruchodpp1 = pruchodpp(1) + pruchodpp(2) + pruchodpp(3) + pruchodpp(4);  %kontrolni promenna
PSI_INT_C2pp_RESULT = PSI_INT_C2pp(1) + PSI_INT_C2pp(2) + PSI_INT_C2pp(3) + PSI_INT_C2pp(4) ; %indexy v zavorkach znamenaji oblast ve ktere se integrovalo (vytvori se vlastne sloupcovy vektor, kde jednotlive radky jsou integrace pres jednotlive oblasti)

% ***** V Y P O C E T    G S I F ****************************************

%PSI_INT_C1=-0.3428429918e-3 %hodnota integralu z MAPLU
GSIFapp =( PSI_INT_C2pp_RESULT / PSI_INT_C1pp_RESULT )  %spocita hodnotu GSIF a vypise do radky
%************************************************************************

%**************************************************************************
%************************ P   L   O  T  ***********************************
%**************************************************************************
%***** PLOT HODNOT Z MATICE Bsel - MKP RESENI a ANALYTICKE RESENI VYNASOBENE Hckem - pro porovnn **************
figure(9),
%set(figure(9),'PaperType','A4');
subplot(2,3,1); 
                plot(Bsel(:,1),      Bsel(:,3) ,'Color','b','LineWidth',2); hold on; 
                plot(Bsel(:,1), GSIFapp*Bsel(:,23),'Color','r','LineWidth',2); hold off; grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_x (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 

subplot(2,3,2); 
                plot(Bsel(:,1),      Bsel(:,4) ,'Color','b','LineWidth',2); hold on;
                plot(Bsel(:,1), GSIFapp*Bsel(:,24),'Color','r','LineWidth',2); hold off;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_y (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 

title(['RESENI Z MKP vs SINGULARNI RESENI x H - na kruhove draze R=',num2str(RC2*10^3),'mm'],'FontName','times','FontSize',14,'FontWeight','bold'), 
   
subplot(2,3,4); 
                plot(Bsel(:,1),      Bsel(:,5) ,'Color','b','LineWidth',2); hold on; 
                plot(Bsel(:,1), GSIFapp*Bsel(:,25),'Color','r','LineWidth',2); hold off; grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_x (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 

subplot(2,3,5); 
                plot(Bsel(:,1),      Bsel(:,6) ,'Color','b','LineWidth',2); hold on; 
                plot(Bsel(:,1), GSIFapp*Bsel(:,26),'Color','r','LineWidth',2); hold off; grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_y_y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 

legend('MKP RESENI',['SINGULARNI RESENI - \sigma_i_j=H*r^\delta^-^1*f(\theta)','...kde ','H=',num2str(GSIFapp),'MPa*m^1^-^\delta'],2,'Location','Best');

subplot(2,3,6); 
                plot(Bsel(:,1),      Bsel(:,7) ,'Color','b','LineWidth',2); hold on; 
                plot(Bsel(:,1), GSIFapp*Bsel(:,27),'Color','r','LineWidth',2); hold off; grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_x_y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold')

% text(1,1,'\sigma_i_j=H*r^\delta^-^1*f(\theta)','FontSize',14,'FontWeight','bold');
% text(1,0,['H=',num2str(GSIFapp),' MPa*m^1^-^\delta'],'FontSize',20,'FontWeight','bold');
% text(.025,.6,['H=',num2str(GSIFapp),' MPa*m^1^-^\delta'],'FontSize',12)

 %   legend('MKP RESENI','SINGULARNI RESENI',2,'Location','SouthEast');
 %   text(1,0.06,['\sigma_i_j=H*r^\delta^-^1*f(\theta)','...kde ''H=',num2str(GSIFapp),'MPa*m^1^-^\delta'],'FontSize',20,'FontWeight','bold');
%   ,'Location','SouthEastOutside'

saveas(figure(9),'VYPOCTY\MKPvsSingularni_reseni','fig');
saveas(figure(9),'VYPOCTY\MKPvsSingularni_reseni','jpg');
