%*************************************************************
%*  Ing. OLDICH EVEEK v rmci projetku FRV 2421/2007/G1 *
%*************************************************************

clear all,
poradidelta=1;  %toto je promenna, ktera udava, ktere delta uvazujeme (1 - uvazujeme delta z intervalu(0,1) ; 2 - uvazujeme delta z intervalu (1,2) (podle toho se pak meni v souboru singularsol vstupni soubor z MAPLU
%Tento soubor nacte hodnoty z ansysu, vypocita hodnoty pomocneho reseni
%pomoci m-filu singularsol (pro prislusne uhly odpovidajici uhlum nodu z ansysu a nasledne tyto dve hodnoty spolu pro integruje
%na integracni ceste RC3
%**************************************************************************
%*********** I N P U T   O B L A S T **************************************
%**************************************************************************
alfa=0;        %uhel trhliny od zaporne osy X
pripona='';    %mono zvolit libovolnou priponu souboru - napriklad pri provadeni parametrickych studii k odliseni vypoctu
GSIFappl=6.6;  %zde se zad hodnota vypoctenho aplikovanho zobecnnho souinitele intensity napt - viz metodick list.1 - pro ppad nepemostn trhliny
ZATIZENI=100;   %hodnota aplikovanho zatizeni pro ktery se potala hodnota GSIFappl

TL=4;          % Tloustka povrchove vrstvy
uzlu=194;      % Pocet uzlu podl licu trhliny do kterych aplikujeme v MKP izolovanou dvojici sil (viz nazev vystupnich soubor z ansysu a velicina NN)
R3=3.9;        % Polomer integracni cesty R3 - viz nazev vystupniho souboru z ansysu
IZOLSILA=1000; % Velikost izolovane sily zadavane v ansysu (po prepoctu dostaneme jednotkovou silu)

%**************************************************************************
Br_Model='2'   %zadanim hodnoty u teto promenne se urci, ktery model premosteni se pro vypocet pouzije
%1 - bude pocitat jednoduchy Budianskeho model premosteni
%2 - bude pocitat pokrocily model premosteni uvazujici vytahovani vlaken
%**************************************************************************
cf = 0.4 ;     % Objemovy podil vlaken
Ef = 228000 ;  %(MPa) modul pruznosti v tahu vlaken 
Em = Ef/3 ;    %(MPa) modul pruznosti v tahu matrice 
Ec = 137000 ;  %(MPa) modul pruznosti celkov kompozitu (ve smeru osy x)
R =  7*10^(-3) % Polomer vlakna
TAU = 7        %(MPa) smykove napeti - interface slipping shear resistance stress
mm = 3;        % koeficient weibullova rozdeleni do vypoctu premosteni u modelu s vytahovanim vlaken
pretrzenivlaken=2000 ; %hodnota v MPA pi kter dojde k petren vlken

VNAPETI =   1;  %napt, kterm je vzorek zatizen na hranici v ANSYSU (je to schvalne jednotkove, aby bylo mozne potom prepocitat otevreni na libovolne napeti - uvazujeme linern vpoet)
ISOLFORCE = 1;  %velikost izolovane sily, kterou je vzorek zatizen na lici trhliny

% do nasledujici promenne Stress_range zadame pocatecni a koncovou hodnotu
% vnejsiho napeti, pro kterou chceme pocitat Hbr (abychom dostali jeho
% zvislost na aplikovanm zaten)
Stress_range(1)=1;
Stress_range(2)=150;


%***********************************************************************************************
%***** N A C T E  S E   S O U B O R   Z   M K P  S    D A T Y   O   P O S U V U    L I C U *****
%***********************************************************************************************
%Force_faceopening_F=1000_serazenoN=194.txt
filename3=['Force_faceopenings_F=',num2str(IZOLSILA),'_N=',num2str(uzlu),pripona,'.txt'];  %'_opacnematerialy',
f3 = fullfile('MKPdata', filename3)  %prikaz ktery vytvori komplet cestu k danemu souboru
fid=fopen(f3,'r');
%nacteme prvni serii dat (mezi prvni a druhou hlavickou)  
D = textscan(fid, '%f %f %f %f %f', 'headerlines', 1) ;
%ZATNODE  NODENUM   POSUVX   SOURY    SOURYZAT
fclose(fid)       %uzavre soubor pro cteni
posuvy_isolforce_mkp = cell2mat(D);   %cell2mat (prevede CELL na obycejnou matici)

[k,r] = size(posuvy_isolforce_mkp)             %k - pocet radku , r - pocet sloupcu
NN=sqrt(k);                  %zkontroluje zda se opravdu pocet nodu rovna hodnote zadane na zacatku v promenne uzly (musi zde byt NNxNN radku v promenne opening

%v nasledujicim cyklu se z dat MKP posuvu licu vytahnou pouze posuvy pri
%zatizeni v jednotlivych polohach a zapise se to do promenne
%posuvy_isolforce (bude mit rozmer NNxNN)
for i=1:NN;
    for j=1:NN;
        posuvy_isolforce(j,i) = (-1) * posuvy_isolforce_mkp(j+(NN*(i-1)),3);   %zde se udela z dlouheho souboru z MKP tabulka 191x*191, kde kazdy sloupecek bude obsahovat posunuti od zatizeni isolovanymi silami v prislusnem uzlu (minu je tam proto, aby vyslo kladne cislo
    end;
end;
%************************************************************************************************
for i=1:NN
   SOURuzlu(i)=posuvy_isolforce_mkp(NN*i,5);     %do promenne zapise souradnice uzlu do kterych byla aplikovana izolovana sila (bere se vzdy z poslednich sloupecku z MKP dat, kde je souradnice zatizeneho uzlu
end;

%***************************************************************************************************** 
%***** N A C T E  S E   S O U B O R   Z   M K P  S    D A T Y  O  U Z L E C H  N A  C E S T E   R3 
%****************************************************************************************************
%Bridge_Path_R3=3.9_F=1000_serazenoN=194.txt
filename2=['Bridging_Path_R3=',num2str(R3),'_F=',num2str(IZOLSILA),'_N=',num2str(uzlu),pripona,'.txt'];  %'_opacnematerialy',
f2 = fullfile('MKPdata', filename2)  %prikaz ktery vytvori komplet cestu k danemu souboru
fid=fopen(f2,'r');
%nacteme prvni serii dat (mezi prvni a druhou hlavickou)  
C = textscan(fid, '%f %f %f %f %f %f %f %f %f %f %f ', 'headerlines', 1) ;
% NODE  SOURX  SOURY  SOURR   SOURFI  POSUVX  POSUVY  POSUVSUM NAPX   NAPY  NAPXY   
fclose(fid)       %uzavre soubor pro cteni
uzlyR3 = cell2mat(C);   %cell2mat (prevede CELL na obycejnou matici)

uzlunaR3=length(uzlyR3)/uzlu;
%nasledujici cyklus vytvori 3D matici, kde kazda uroven bude obsahovat matici pri zatizeni v prislusnem uzlu
for i=1:NN;  
     uzly_intcestaR3(:,:,i) =  uzlyR3(uzlunaR3*(i-1)+1:uzlunaR3*i,:);   %zde se udela z dlouheho souboru z MKP tabulka 191x*191, kde kazdy sloupecek bude obsahovat posunuti od zatizeni isolovanymi silami v prislusnem uzlu
end;
%************************************************************************************************

for i=1:NN;  
   sortrows(uzly_intcestaR3(:,:,i),[2]);
end;

%plot(SOURuzlu, posuvy_isolforce(:,1));
%COD = sortrows(opening,[2]);

%*************ZDE SE NACTE INTEGRACNI POLOMER - ze souboru UZLY *****
RC3 =uzlyR3(1,4) * 10^-3;    %ve ctvrtem sloupci jsou hodnoty polomeru integracni cesty - nasobime jeste 10^-3 - prevedeme na metry
%********************************************************************
%********************************************************************
%****** Zacatek hlavniho cyklu - urovne ve 3D matici (kazda uroven ma info
%o jedne integracni ceste pro prislusnou polohu izolovane dvojice
%********************************************************************
for ii=1:NN; %NN
%********************************************************************
POL=SOURuzlu(ii); %do promenne POL se ulozi poloha isolovane dvojice sil od korene v danem kroku ii

 nodes = zeros(uzlunaR3,r+1+4,NN);   % +1 kvuli moznosti pridat 1 sloupec na relativni posuv vzhledem ke koreni (vynechavame zaroven sloupec SOURR) a +4 pro pridani 2 posuvu a 2 napeti z reseni vlastniho problemu
 nodes(1:uzlunaR3,1,ii)    =uzly_intcestaR3(1:uzlunaR3,5,ii);       %1.sloupec budou uhly nodu od pocatku
 nodes(1:uzlunaR3,2,ii)    =uzly_intcestaR3(1:uzlunaR3,1,ii);       %2.sloupec budou cisla uzlu
 nodes(1:uzlunaR3,3:4,ii)  =uzly_intcestaR3(1:uzlunaR3,2:3,ii);   %3-4 sloupec budou x a y souradnice uzlu pred deformaci
 nodes(1:uzlunaR3,5:10,ii)=uzly_intcestaR3(1:uzlunaR3,6:11,ii);  %5-10 sloupec budou 5-'POSUVX',6-'POSUVY',7-'POSUVSUM',8-'NAPX',9-'NAPY',10-'NAPXY'


 nodes(:,16,ii)=nodes(:,5,ii);     %do 16teho sloupecku se ulozi relativni posuv uzlu vzhledem ke koreni trhliny ve smeru X
 nodes(:,17,ii)=nodes(:,6,ii);     %do 17teho sloupecku se ulozi relativni posuv uzlu vzhledem ke koreni trhliny ve smeru Y

%nsledujc cykly akort sead uzly v matici nodes tak aby byli postupne
%jak jdou od dolnho (praveho) cela podl integran cesty k hornmu (levmu) elu trhliny
for j=1:uzlunaR3,
   if nodes(j,1,ii)<0
        nodes(j,18,ii)=nodes(j,1,ii)+360;     %jestli je uhel nodu zaporny, tak se k nemu pricte 360 stupnu a dostaneme tak kladny uhel od osy x
   else 
       nodes(j,18,ii)=nodes(j,1,ii);          %je-li uhel nodu kladny, pak se nic nedeje-jen se cislo prepise.
   end

   nodes(j,19,ii)=nodes(j,18,ii)-(270+alfa);%(180+alfa)  %do dalsiho sloupecku se provede natoceni SS, tak aby nulovy uhel byl v miste trhliny
 
   if nodes(j,19,ii)<0                      
      nodes(j,19,ii)=nodes(j,19,ii)+360;       %je li hodnota uhlu zaporna, pricte se 360 stupnu - abychom meli pouze kladne uhly.
   end
end

%nyn projdeme vsechny nody (2 z nich jsou zde dvakrat - horni a dolni
%celo) a my musime rozhodnout ktery z nich je ktery. Potrebujeme nody
%seradit aby integracni cesta vedla od spodniho cela dokola k hornimu celu celu
%- protismeru hodinovych rucicek.

B(:,:,ii) = sortrows(nodes(:,:,ii),[19]);      %nody seradime podle 19.teho sloupcecku - dostaneme tak integracni cestu od dolniho cela dokola po horni celo

poradi=1;
  for j=1:uzlunaR3,
    if  B(j,18,ii)==(270+alfa)        %Je li uhel prisl. uzlu roven uhlu cela trhliny, pak se ulozi do promene CELO hodnota radku kde se tento uzel nachazi a do promenne PosuvY se ulozi hodnota relativniho posuvu Y vzhledem pocatku. ( podminky IF musi byt pro rovnost dve rovnitka)
        celo(poradi)=j;
        posuvX(poradi)=B(j,16,ii);  
        poradi=poradi+1;             %nali li jsme jeden shodny uhel,tak se poradi zvedne o 1 - abychom mohli ukladat do druheho sloupecku promennych CELO a POSUVY dalsi uzel
    end

  end

  if posuvX(1)<posuvX(2)         %je li relativni X posuv nodu v prvnim radku zaporny (je mensi nez Y posuv v druhem radku)
     B(celo(1),19,ii) = 360;
 %     B(uzlunaR3+1,:,ii)=B(celo(2),:,ii) ;         
 %     B(celo(2),:,ii) = [] ;       %vymaze  radek z matice B, ktery obsahuje udaje, ktere jsme v predchozim kroku ulozili na posledni radek 
  end

  if posuvX(1)>posuvX(2)         %je li relativni X posuv nodu v prvnim radku kladny (je vetsi nez Y posuv v druhem radku)
     B(celo(2),19,ii) = 360;
%      B(uzlunaR3+1,:,ii)=B(celo(1),:,ii);       %tak se na posledni radek+1 matice B ulozi hodnoty uzlu na hornim cele trhliny
%      B(celo(1),:,ii) = [] ;        %vymaze  radek z matice B, ktery obsahuje udaje, ktere jsme v predchozim kroku ulozili na posledni radek 
  end

 B(:,:,ii) = sortrows(B(:,:,ii),[19]);      %nody seradime podle 19.teho sloupcecku - dostaneme tak integracni cestu od dolniho cela dokola po horni celo

%B(uzlunaR3,19,ii)=360;     %posledni hodnota ve sloupci 19 je  uhel 360 stupnu (je tam puvodne vepsana nula-natvrdo prepiseme)

%MATICE B - CO OBSAHUJE:

% 1-'SOURFI', 2-'CISLONODU', 3-'SOURX',4-'SOURY',5-'POSUVX',6-'POSUVY'
%,7-'POSUVSUM',8-'NAPX',9-'NAPY',10-'NAPZ',11-'NAPXY',12-'NAPYZ',13-'NAPXZ'
%,14-'NAPINT',15-'NAPEQV', 16-'RELPOSUV X', 17-'RELPOSUV Y'
%,18-'SOURFI 0-360',  19-'SOURFI 0-360-pocatekVtrhline', 20-'U1b', 21-'U2b',  22-'SOURFI
%**************************************************************************
%******Do promenne Bsel  ulozime pouze hodnoty ktere budeme nutne
%potrebovat do vypoctu Psi integralu (k integraci)************************
 Bsel = zeros(uzlunaR3,12,NN);              %vytvori prazdnou matici k*12
 Bsel(:,1,ii) = B(:,19,ii);             %do 1. sloupecku ulozime uhel ve stupnich 0-360
 Bsel(:,2,ii) = Bsel(:,1,ii)* pi/180;   %do 2. sloupecku ulozime uhel v radianech 0-2pi
 Bsel(:,3,ii) = 10^-3*B(:,16,ii);              %do 3 sloupecku se ulozi UX z MKP (m) %10^3 prevede mm z ansysu na metry
 Bsel(:,4,ii) = 10^-3*B(:,17,ii);              %do 4. sloupecku se ulozi UY z MKP (m)%10^3 prevede mm z ansysu na metry
 Bsel(:,5,ii) = B(:,8,ii);              %do 5. sloupecku se ulozi SX z MKP (MPa)
 Bsel(:,6,ii) = B(:,9,ii);              %do 6. sloupecku se ulozi SY z MKP (MPa)
 Bsel(:,7,ii) = B(:,10,ii);             %do 7. sloupecku se ulozi SXY z MKP (MPa)
%v nasledujicim cyklu se do sloupce 8-12 pomoc funkce singularsol vypoctou
%pro prislusne uhly hodnoty UXpom,UYpom,SXpom,SYpom,SXYpom - pomocne reseni
for t=1:uzlunaR3,
uheltheta=Bsel(t,1,ii);  %zde se v tomto cyklu vypoctou hodnoty pomocneho reseni na polomeru RC3
 [UXpom,UYpom,SXpom,SYpom,SXYpom] = SingularSolution(uheltheta,RC3,1,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC3; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,8,ii)  = UXpom;   %do 8. sloupecku se ulozi UX pomocneho reseni (m)
  Bsel(t,9,ii)  = UYpom;   %do 9. sloupecku se ulozi UY pomocneho reseni (m)
  Bsel(t,10,ii) = SXpom;   %do 10. sloupecku se ulozi SX pomocneho reseni (MPa)
  Bsel(t,11,ii) = SYpom;   %do 11. sloupecku se ulozi SY pomocneho reseni (MPa)
  Bsel(t,12,ii) = SXYpom;  %do 12. sloupecku se ulozi SXY pomocneho reseni (MPa)
end;
for t=1:uzlunaR3,
uheltheta=Bsel(t,1,ii);  %zde se v tomto cyklu vypoctou hodnoty singularniho reseni na polomeru 1
  [UXsin,UYsin,SXsin,SYsin,SXYsin] = SingularSolution(uheltheta,1,2,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,13,ii) = UXsin;  %do 13. sloupecku se ulozi UX singularniho reseni (MPa)
  Bsel(t,14,ii) = UYsin;  %do 14. sloupecku se ulozi UY singularniho reseni (MPa)
  Bsel(t,15,ii) = SXsin;  %do 15. sloupecku se ulozi SX singularniho reseni (MPa)
  Bsel(t,16,ii) = SYsin;  %do 16. sloupecku se ulozi SY singularniho reseni (MPa)
  Bsel(t,17,ii) = SXYsin;  %do 17. sloupecku se ulozi SXY singularniho reseni (MPa)
end;
for t=1:uzlunaR3,
uheltheta=Bsel(t,1,ii);  %zde se v tomto cyklu vypoctou hodnoty pomocneho reseni na polomeru 1
 [UXpom,UYpom,SXpom,SYpom,SXYpom] = SingularSolution(uheltheta,1,1,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC3; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,18,ii) = UXpom;   %do 18. sloupecku se ulozi UX pomocneho reseni (m)
  Bsel(t,19,ii) = UYpom;   %do 19. sloupecku se ulozi UY pomocneho reseni (m)
  Bsel(t,20,ii) = SXpom;   %do 20. sloupecku se ulozi SX pomocneho reseni (MPa)
  Bsel(t,21,ii) = SYpom;   %do 21. sloupecku se ulozi SY pomocneho reseni (MPa)
  Bsel(t,22,ii) = SXYpom;  %do 22. sloupecku se ulozi SXY pomocneho reseni (MPa)
end;

for t=1:uzlunaR3,
uheltheta=Bsel(t,1,ii);  %zde se v tomto cyklu vypoctou hodnoty singularniho reseni na polomeru RC3 - budeme potrebovat pro vykreseleni a porovnani hodnot z MKP a anylytickho resen
  [UXsin,UYsin,SXsin,SYsin,SXYsin] = SingularSolution(uheltheta,RC3,2,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Bsel(t,23,ii) = UXsin;  %do 23. sloupecku se ulozi UX singularniho reseni (MPa)
  Bsel(t,24,ii) = UYsin;  %do 24. sloupecku se ulozi UY singularniho reseni (MPa)
  Bsel(t,25,ii) = SXsin;  %do 25. sloupecku se ulozi SX singularniho reseni (MPa)
  Bsel(t,26,ii) = SYsin;  %do 26. sloupecku se ulozi SY singularniho reseni (MPa)
  Bsel(t,27,ii) = SXYsin;  %do 27. sloupecku se ulozi SXY singularniho reseni (MPa)
end;

PROVEST=0;

if PROVEST==1
%***** PLOT HODNOT Z MATICE Bsel - MKP RESENI **************
figure(5),
subplot(2,3,1); plot(Bsel(:,1,ii), Bsel(:,3,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny MKP - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy UX (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
subplot(2,3,2); plot(Bsel(:,1,ii), Bsel(:,4,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy UY (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,3); plot(Bsel(:,1,ii), Bsel(:,5,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny MKP - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SXX (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,4); plot(Bsel(:,1,ii), Bsel(:,6,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny MKP - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SYY (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,5); plot(Bsel(:,1,ii), Bsel(:,7,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny  MKP- []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SXY (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title('RESENI Z MKP v SS MAPLU','FontName','times','FontSize',14,'FontWeight','bold'), 


%***** PLOT HODNOT Z MATICE Bsel -pomocne reseni (singul.res)**************
figure(6),
subplot(2,3,1); plot(Bsel(:,1,ii), Bsel(:,8,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy UX (m)-pomocne reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
subplot(2,3,2); plot(Bsel(:,1,ii), Bsel(:,9,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy UY (m)-pomocne reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,3); plot(Bsel(:,1,ii), Bsel(:,10,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SXX (MPa)-pomocne reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,4); plot(Bsel(:,1,ii), Bsel(:,11,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SYY (MPa)-pomocne reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,5); plot(Bsel(:,1,ii), Bsel(:,12,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SXY (MPa)-pomocne reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
 title('Pomocne reseni v SS MAPLU','FontName','times','FontSize',14,'FontWeight','bold'), 

 %***** PLOT HODNOT Z MATICE Bsel -Singularni reseni **************
figure(7),
subplot(2,3,1); plot(Bsel(:,1,ii), Bsel(:,13,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy UX (m)-singularni reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
subplot(2,3,2); plot(Bsel(:,1,ii), Bsel(:,14,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy UY (m)-singularni reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,3); plot(Bsel(:,1,ii), Bsel(:,15,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SXX (MPa)-singularni reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,4); plot(Bsel(:,1,ii), Bsel(:,16,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SYY (MPa)-singularni reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   
subplot(2,3,5); plot(Bsel(:,1,ii), Bsel(:,17,ii)) ;grid on;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti SXY (MPa)-singularni reseni'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
 title('Singularni reseni','FontName','times','FontSize',14,'FontWeight','bold'), 

end;
%Nyni vytvorime tabulku hodnot, ktere nasledovne pouzijem pro integraci
%******** TABULKA_PRO_INTEGRACI ***************************************

tabulka_pro_integraci=zeros(uzlunaR3,8,NN);   %vytvori se prazdna matice o osmi sloupcich a poctu radku k - pocet zaznamu z MKP

tabulka_pro_integraci(:,1,ii)=Bsel(:,1,ii);     %1. sloupec v matici tabulka_pro_integraci budou uhly nodu 'SOURFI 0-360-pocatekVtrhline
tabulka_pro_integraci(:,2,ii)=Bsel(:,2,ii);     %2. sloupec budou hodnoty sloupce 1. ale v RADIANECH

%Nyn budeme pocitat nasledujici vyraz pro jednotlive uzly a vse ukladat do
%tabulky pro integraci
%S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b

%VEKTOR vnejsi normaly je pro SS maplu ( cos(theta + natoceni), sin(theta + natoceni))
   
nat= -pi/2;   %natoceni trhliny vi kladn ose X (osa X smeruje v ansysu o 90 stupnu pootocena k trhline)

%zde se ulozi hodnoty pro integracni cestu C3=R
for j=1:uzlunaR3  %POZN: a - reseni MKP, b - pomocne reseni - na integracni ceste C3
%                               S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b
    tabulka_pro_integraci(j,3,ii)=( Bsel(j,5,ii)*cos(Bsel(j,2,ii)+nat)*Bsel(j,8,ii))+(Bsel(j,7,ii) *sin(Bsel(j,2,ii)+nat) *  Bsel(j,8,ii))+(Bsel(j,7,ii) *cos(Bsel(j,2,ii)+nat)* Bsel(j,9,ii))+(Bsel(j,6,ii) * sin(Bsel(j,2,ii)+nat)* Bsel(j,9,ii));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXa     *      n1       *    UXb  )+(    SXYa  *       n2       *      UXb  )+(    SYXa  *        n1     *     UYb  )+(    SYa   *        n2     *    UYb   )                *  
    tabulka_pro_integraci(j,4,ii)=(Bsel(j,10,ii)*cos(Bsel(j,2,ii)+nat)*Bsel(j,3,ii))+(Bsel(j,12,ii)*sin(Bsel(j,2,ii)+nat) *  Bsel(j,3,ii))+(Bsel(j,12,ii)*cos(Bsel(j,2,ii)+nat)* Bsel(j,4,ii))+(Bsel(j,11,ii)* sin(Bsel(j,2,ii)+nat)* Bsel(j,4,ii));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXb     *      n1       *    UXa  )+(    SXYb  *       n2       *      UXa  )+(    SYXb  *        n1     *     UYa  )+(    SYb   *        n2     *    UYa   )                *  

  tabulka_pro_integraci(j,5,ii)=tabulka_pro_integraci(j,3,ii)-tabulka_pro_integraci(j,4,ii);
end;
%zde se ulozi hodnoty pro integracni cestu C1=0
for j=1:uzlunaR3  %POZN: a - singularni reseni, b - pomocne reseni - na integracni ceste C1
%                               S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b
    tabulka_pro_integraci(j,6,ii)=( Bsel(j,15,ii)*cos(Bsel(j,2,ii)+nat)*Bsel(j,18,ii))+(Bsel(j,17,ii) *sin(Bsel(j,2,ii)+nat) *  Bsel(j,18,ii))+(Bsel(j,17,ii) *cos(Bsel(j,2,ii)+nat)* Bsel(j,19,ii))+(Bsel(j,16,ii) * sin(Bsel(j,2,ii)+nat)* Bsel(j,19,ii));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXa      *      n1          *    UXb  )+(    SXYa  *       n2          *      UXb  )+(    SYXa    *        n1        *     UYb  )+(    SYa    *        n2         *    UYb   )                *  
    tabulka_pro_integraci(j,7,ii)=( Bsel(j,20,ii)*cos(Bsel(j,2,ii)+nat)*Bsel(j,13,ii))+(Bsel(j,22,ii) *sin(Bsel(j,2,ii)+nat) *  Bsel(j,13,ii))+(Bsel(j,22,ii) *cos(Bsel(j,2,ii)+nat)* Bsel(j,14,ii))+(Bsel(j,21,ii) * sin(Bsel(j,2,ii)+nat)* Bsel(j,14,ii));  %ve druhem sloupecku bude 1.clen uvnitr integralu
%                              (  SXb     *      n1          *    UXa   )+(    SXYb  *       n2          *      UXa  )+(    SYXb   *        n1        *     UYa   )+(   SYb    *        n2         *    UYa   )                *  

  tabulka_pro_integraci(j,8,ii)=tabulka_pro_integraci(j,6,ii)-tabulka_pro_integraci(j,7,ii);
end;


%*********************SLOZENI TABULKY_PRO_INTEGRACI ************************
%SLOUPCE
% 1-uhly ve stupnich v nich je vycislena prislusna velicina 0-360stupnu
% 2-uhly z 1 v radianech 
% 3-soucty prvniho clenu v PSI-integralu (krivka C3) - MKP a POMOCNE
% 4-soucty druheho clenu v PSI-integralu (krivka C3) - MKP a POMOCNE
% 5-rozdil obou hodnoty (3-4)- defakto celkova funkcni hodnota (krivka C3)

% 6-soucty prvniho clenu v PSI-integralu (krivka C1) - SINGULARNI a POMOCNE
% 7-soucty druheho clenu v PSI-integralu (krivka C1) - SINGULARNI a POMOCNE
% 8-rozdil obou hodnoty (6-7)- defakto celkova funkcni hodnota (krivka C1)
%**************************************************************************

figure(8), %vykresli se do grafu 4 funkce kterou vlastne budeme integrovat - cely vnitrek integralu
%plot(tabulka_pro_integraci(:,1),tabulka_pro_integraci(:,3)),hold on
%plot(tabulka_pro_integraci(:,1),tabulka_pro_integraci(:,4)),hold on
subplot(2,1,1);
  plot(tabulka_pro_integraci(:,1,ii),tabulka_pro_integraci(:,5,ii),'Color','b','LineWidth',2),hold on; %integrand na ceste R2
  xlim([0 360]);  set(gca,'xtick',[0 45 90 135 180 225 270 315 360]); grid on;
  title('Prubeh integrovane funkce na ceste C3','FontName','times','FontSize',14,'FontWeight','bold'), 
  legend('Integracni cesta C3 - r=R',1);
subplot(2,1,2);
  plot(tabulka_pro_integraci(:,1,ii),tabulka_pro_integraci(:,8,ii),'Color','r','LineWidth',2),hold on; %integrand na ceste R1
  xlim([0 360]);  set(gca,'xtick',[0 45 90 135 180 225 270 315 360]); grid on;
  title('Prubeh integrovane funkce na ceste C1','FontName','times','FontSize',14,'FontWeight','bold'), 
  legend('Integracni cesta C1 - r=0',1);
%INTEGRACE PODEL KRIVEK C1 a C3 - pouzita bude SIMPSONOVA METODA

Deleni_kruznice = size(tabulka_pro_integraci,1)-1;
P_intervalu = Deleni_kruznice/2            %pocet integracnich intervalu (pri simpsonove metode se proklada parabola 3-mi body, proto jsou potreby pro jeden interval 3 funkcni hodnoty

%***********************************************************
PSI_INT_C3=0;  %pocatecni hodnota PSI integralu na krivce C3
PSI_INT_C1=0;  %pocatecni hodnota PSI integralu na krivce C1
%***********************************************************

X = tabulka_pro_integraci; %pro zjednoduseni zapisu v dalsich vypoctech, ulozime "tabulku_pro_integraci" do promenne X


%**************************************************************************
% I N T E G R A C E   P R E S   C3   - R = RC3 
%**************************************************************************
pruchod=0;  %kontrolni promenna
%*******zde bude pro integraci pouzita SIMPSONOVA METODA**********
RC3=RC3;  % integraci provadime v jednotkach metry a MPA
for i=1:2:size(tabulka_pro_integraci,1)-2,   %zjisti prvni rozmer pole tabulka_pro_integraci %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     PSI_INT_C3 = PSI_INT_C3 + RC3*((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,5,ii) + 4*X(i+1,5,ii) + X(i+2,5,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%**************************************************************************
%Zde v nasledujicim  zkusime integraci po castech v kazdem materialu budeme integrovat zvlast- na rozhrani je totiz nespojitost - skokova zmena a ta
%muze pri numericke integraci zpusobovat chybu.
for t=1:uzlunaR3, if X(t,1,ii)<( 90-alfa), rozhrani1=t; end; end;  %do promenne rozhrani ulozi radkovou pozici dolniho rozhrani v matici X
for t=1:uzlunaR3, if X(t,1,ii)<(270-alfa), rozhrani2=t; end; end;  %do promenne rozhrani ulozi radkovou pozici horniho rozhrani v matici X
rozhrani1=rozhrani1 + 1;  %je zde plus jedna, protoze se potrebujeme dostat tesne pred skokovou zmenu prubehu integrovane funkce
rozhrani2=rozhrani2    ;

PSI_INT_C3b=0;  
pruchod=0;
%Integrace od spodniho cela na rozhrani (2.VARIANTA INTEGRACE)
for i=1:2:rozhrani1,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     PSI_INT_C3b = PSI_INT_C3b + RC3*((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,5,ii) + 4*X(i+1,5,ii) + X(i+2,5,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%Integrace od rozhrani po rozhrani - v zakladnim materialu
for i=(rozhrani1+1):2:rozhrani2,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     PSI_INT_C3b = PSI_INT_C3b + RC3*((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,5,ii) + 4*X(i+1,5,ii) + X(i+2,5,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%Integrace od rozhrani po horni celo trhliny - v povrchove vrstve
for i=(rozhrani2+1):2:size(tabulka_pro_integraci,1)-2,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
   PSI_INT_C3b = PSI_INT_C3b + RC3*((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,5,ii) + 4*X(i+1,5,ii) + X(i+2,5,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
   pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
PSI_INT_C3b= PSI_INT_C3b + ((X(rozhrani1,5,ii)+X(rozhrani1+1,5,ii))/2 * (RC3*(abs(X(rozhrani1,2,ii)-X(rozhrani1+1,2,ii))) )); %zde se jeste do integralu prictou hodnoty v miste nespojitosti - v miste rozhrani, ktere jsme v predchozich krocich vynechali (zde je to spodni rozhrani)
PSI_INT_C3b= PSI_INT_C3b + ((X(rozhrani2,5,ii)+X(rozhrani2+1,5,ii))/2 * (RC3*(abs(X(rozhrani2,2,ii)-X(rozhrani2+1,2,ii))) )); %zde se jeste do integralu prictou hodnoty v miste nespojitosti - v miste rozhrani, ktere jsme v predchozich krocich vynechali (zde je to horni rozhrani)

%**************************************************************************


%**************************************************************************
% I N T E G R A C E   P R E S   C1   - R = 0 
%**************************************************************************
pruchod=0;
for i=1:2:size(tabulka_pro_integraci,1)-2,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     PSI_INT_C1 = PSI_INT_C1 + ((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,8,ii) + 4*X(i+1,8,ii) + X(i+2,8,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%Zde v nasledujicim  zkusime integraci po castech v kazdem materialu budeme integrovat zvlast- na rozhrani je totiz nespojitost - skokova zmena a ta
%muze pri numericke integraci zpusobovat chybu.
PSI_INT_C1b=0;  
pruchod=0;
%Integrace od spodniho cela na rozhrani (2.VARIANTA INTEGRACE)
for i=1:2:rozhrani1,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     PSI_INT_C1b = PSI_INT_C1b + ((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,8,ii) + 4*X(i+1,8,ii) + X(i+2,8,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%Integrace od rozhrani po rozhrani - v zakladnim materialu
for i=(rozhrani1+1):2:rozhrani2,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     PSI_INT_C1b = PSI_INT_C1b + ((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,8,ii) + 4*X(i+1,8,ii) + X(i+2,8,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%Integrace od rozhrani po horni celo trhliny - v povrchove vrstve
for i=(rozhrani2+1):2:size(tabulka_pro_integraci,1)-2,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     PSI_INT_C1b = PSI_INT_C1b + ((X(i+2,2,ii)-X(i,2,ii))/6) * (X(i,8,ii) + 4*X(i+1,8,ii) + X(i+2,8,ii));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
PSI_INT_C1b= PSI_INT_C1b + ((X(rozhrani1,8,ii)+X(rozhrani1+1,8,ii))/2 * ((abs(X(rozhrani1,2,ii)-X(rozhrani1+1,2,ii))) )); %zde se jeste do integralu prictou hodnoty v miste nespojitosti - v miste rozhrani, ktere jsme v predchozich krocich vynechali (zde je to spodni rozhrani)
PSI_INT_C1b= PSI_INT_C1b + ((X(rozhrani2,8,ii)+X(rozhrani2+1,8,ii))/2 * ((abs(X(rozhrani2,2,ii)-X(rozhrani2+1,2,ii))) )); %zde se jeste do integralu prictou hodnoty v miste nespojitosti - v miste rozhrani, ktere jsme v predchozich krocich vynechali (zde je to horni rozhrani)


%**************************************************************************
%****** Nyni vypocteme prispevek od jednotkove sily  Fi * pomocne reseni ui
%**************************************************************************

[UXpom,UYpom,SXpom,SYpom,SXYpom] = SingularSolution(0,abs(POL),1,poradidelta);  %vypocte pomocne reseni pro x=0, yb) - 0 znamena celo trhliny a abs(POL) je polomer yb kde pusobi silova dvojice
Vliv_izolsily(ii) = 2*IZOLSILA*10^-3 * (UXpom) ;         %toto je vypocet clenu pro GSIF, ktery zahrnuje dve izolovane sily

%**************************************************************************
% ***** V Y P O C E T    G S I F ******************************************
% %toto je normalni hodnota GSIF po draze RC3
%**************************************************************************
%PSI_INT_C1=-0.3428429918e-3 %hodnota integralu z MAPLU
%GSIF(ii) =( PSI_INT_C3b / PSI_INT_C1b )  %spocita hodnotu GSIF a vypise do radky
%************************************************************************

GSIFbridge(ii) = (PSI_INT_C3b + Vliv_izolsily(ii)) / PSI_INT_C1b

GSIFbridge_inf(ii)= Vliv_izolsily(ii) / PSI_INT_C1b


%**********************************************************************************
end; %konec cyklu pres urovne 3D matice ii parametr
%**********************************************************************************

%nasledujici dva radky zajisti to, aby vahova funkce vypadala na rozhrani
%hezky - jinak je tam kvuli integracni ceste R=3,9 mm zub
slope=GSIFbridge(NN-25)/GSIFbridge(NN-26);
for u=1:6, GSIFbridge(NN-6+u)=GSIFbridge(NN-6+u-1)*slope; end;


%**************************************************************************
%************************ P   L   O  T  ***********************************
%**************************************************************************
%***** vykresli zavislost GSIFbridge na vzdalenosti od korene **************


figure(20),
  plot( SOURuzlu(:)/-TL, GSIFbridge_inf(:)*(TL*10^-3)^0.3283175 ,'Color','b','LineWidth',2); hold on; 
  plot( SOURuzlu(:)/-TL, GSIFbridge(:)*(TL*10^-3)^0.3283175     ,'Color','r','LineWidth',2); hold on; 
  xlim([0 1])
  set(gca,'xtick',[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1],'Visible','on','FontName','Arial','FontSize',12,'FontWeight','normal')
  xlabel('Vzdalenost od korene trhliny (-y/h) - [-]','FontName','arial','FontSize',12,'FontWeight','bold'), 
  ylabel('Hodnota vahove funkce W*h^\delta [-]'  ,'FontName','arial','FontSize',12,'FontWeight','bold'), 
  legend('h/b=1/20','h/b=1/10','h/b=1/5','infinite body',4,'Location','NorthWest');
 grid on;

 
%********************************************************************************************************
%********************************************************************************************************
%****** V nsledujcm vpotu se provede vpoet mostcho napt uitm rekurentnch vztah
%********************************************************************************************************
%********************************************************************************************************


modifikace=1;
%for pretrzenivlaken=2000:300:2000;  %2000:300:2600 ;
%for mm=3:1.5:6 ;

index=1;
for step=Stress_range(1):1:Stress_range(2);  %hodnoty Stress_range se zadavaji na zacatku v input oblasti.
%*************************************************************
%*********** I N P U T   P R E M O S T E N I *****************
%*************************************************************

napeti = step; %530  ;        %(MPa) napeti, kterym chceme aby byl vzorek zatizen
%pretrzenivlaken = 2300 ; %(MPa) - je dano cyklem - viz vyse
pevnostvlaken   = pretrzenivlaken;
pretrzenynod = 200;    %cislo uzlu od ktereho jsou vlakna pretrzena
pocet_iteraci = 210 ;   %pocet iteraci v jednom kroku

nod=170 % cislo nodu ve kterem chceme vykreslit posunuti od isolovane sily
%**************************************************************************
%**************************************************************************
Sigma =(mm+1)^(1/(mm+1))   * pevnostvlaken ;
h=R*Sigma/(2*TAU*(mm+1))  * gamma( (mm+2)/(mm+1) )      ;
%sigmaP = 1.0  *  TAU  *    (h-x)     *   2  /(R)    ;

beta = sqrt((4*cf^2*Ef*Ec^2*TAU)/(R*(1-cf)^2*Em^2)) ;  %36292

%**************************************************************************
%**************************************************************************

%******* N A C T E  S E   S O U B O R   Z   M K P  S    D A T Y  O  P O S U N U T I   L I C U    P R I   Z A T I Z E N I    N A   H R A N I C I
filename1br=['Whole_body_loaded_MPa=',num2str(VNAPETI),'_N=',num2str(NN),pripona,'.txt'];   
f1br = fullfile('MKPdata', filename1br) %prikaz ktery vytvori komplet cestu k danemu souboru - D:\Ansys\matlab work\work\MKPdata
fid=fopen(f1br,'r');
  %nacteme prvni serii dat (mezi prvni a druhou hlavickou)  
  A = textscan(fid, '%f %f %f ', 'headerlines', 1);     %'NODE', 'POSUVX','SOURY',
fclose(fid)       %uzavre soubor pro cteni

posuvy_vn_nap = cell2mat(A);   %cell2mat (prevede CELL na obycejnou matici)
%posuvy_vn_nap(:,2)=10^-3*posuvy_vn_nap(:,2); 
%**************************************************************************
 
  %**************************************************************************
% Do promenne SOUR_UZLU se ulozi cislo uzlu a jeho poloha (ze souboru posuvy_isolforce)
SOUR_UZLU(1:NN,2) = SOURuzlu(1:NN);  

%**************************************************************************

plocha_el(1)= abs (SOUR_UZLU(1,2) - 0);

for i=2:NN;
     plocha_el(i)=abs( SOUR_UZLU(i,2)- SOUR_UZLU(i-1,2) );
end;

plocha_el_total(1)=0;

%**************************************************************************
%************** V Y P O C E T    P R E M O S T E N I **********************
%**************************************************************************
% Bude se pocitat pomoci rekurentni formule - viz clanek T.Vyslouzil,
% M.Kotoul, I.Dlouhy - Modelling the R-curve behavior in chevron-notched
% specimen using weight functions

for i=1:NN;
  stress_opening(i) = napeti * abs(posuvy_vn_nap(i,2));  %toto je rozevreni od napeti psobicho na vnejsku telesa. Nasobi se to napetim, protoze velicina posuvy_vn_napeti je pro napeti na hranici o velikosti 1 MPa
  aproxopening(i)   =   0.25 * stress_opening(i);            %toto je prvni aproximace posuv do rekuretnich vztah (uvazujeme 1/4)
end;
%---------------------
for k=1:pocet_iteraci;                     %delej od jedne do zvoleneho poctu iteraci

    for j=1:NN; bridgeposuv(j)=0; end;  %vytvori vektor bridgeposuv (zatim pouze nuly) o delce poctu nodu z MKP
        
    for i=1:NN;
      if Br_Model=='1', bridgestress = beta * sqrt(aproxopening(i)); end;  %promenna model se zadava na zacatku v input oblasti a udava o jaky model premosteni se rovna
      if Br_Model=='2', bridgestress = beta*sqrt(aproxopening(i)) * exp (- ( ( beta*sqrt(aproxopening(i)) /(  cf  *   Sigma)))^(mm+1)) + cf * (TAU * (h-aproxopening(i))* 2  /(R)) * ( 1 - exp(- ( ( beta*sqrt(aproxopening(i)) /(  cf  *   Sigma)))^(mm+1))); end;
        if (bridgestress > pevnostvlaken) ; bridgestress = 0 ; end;    %podmnka je-li mostici napeti vypocetne v predchozim kroku vetsi nez pevnost vlaken, pak se nastavi na hodnotu nula (vlakna sou pretrzena a nic se tedy potom uz nenese)
        if (i==pretrzenynod)              ; bridgestress = 0 ; end;    %podmnka je-li i-ty uzel vetsi nez misto odkud jsou nody pretrzeny (pretrzenynod) tak se opet mostici napeti nastavi na nulu (vlakna opet nic nenesou)

        bridgestr(i,k,index)=bridgestress;  %pridano mnou !! - pouze jako kontrolni promenna - ukladaji se do ni mostici napeti ve vsech iteracich a ve vsech zateznych krocich (index))

        for s=1:NN;
           bridgeposuv(s) = bridgeposuv(s) + ( bridgestress * plocha_el(i) * 10^(-3)*posuvy_isolforce(s,i));  %zde vypocitaji posuvy jednotlivych nodu v dusledku premosteni vlakny (je tam 10^-3
       % if (bridgeposuv(s)>stress_opening(s)) ; bridgeposuv(s)=stress_opening(s) ; end;      %podminka ktera nam rika, ze je-li zavreni zpusobene premostenim vetsi nez je otevreni trhliny bez premosteni, tak se jeji velikost nastavi na velikost otevreni bez premosteni     
        end;
    
    end;
    
    for i=1:NN;
         bridgeposuv_iterace(:,k)=bridgeposuv(:);     %pomocna promenna (pouze pro naslednou kontrolu)   %do teto promenne se prubezne ukladaji v kazde iteraci odhady posuvu od premosteni
         aproxopeningold(i) = aproxopening(i);
         aproxopening(i)    = aproxopening(i) * stress_opening(i) / ( aproxopening(i) + bridgeposuv(i));
    end;
        
    %zde se uri chyba v kad iteraci k
    chyba(k)=0;
    for i=1:NN;
        chyba(k) = chyba(k) + ( (aproxopening(i)- aproxopeningold(i)) / aproxopening(i) )^2;  %zde se v kazde iteraci ulozi chyba do promenne chyba(k) - k=0-pocet iteraci
    end;
  
end;
%---------------------
chyby(index)=chyba(pocet_iteraci)  %do promenne chyby se budou zapisovat chyby na konci iteraci v jednotlivych zatezovacich krocich


%**************************************************************************
%********* P L O T   H O D N O T   P O S U V U  ***************************
%**************************************************************************

%[k,r] = size(uzly)             %k - pocet radku , r - pocet sloupcu
%nodes = zeros(k,r+1+4);   % +1 kvuli moznosti pridat 1 sloupec na relativni posuv vzhledem ke koreni (vynechavame zaroven sloupec SOURR) a +4 pro pridani 2 posuvu a 2 napeti z reseni vlastniho problemu
%**************************************************************************
figure(1),
subplot(2,3,1); plot(abs(SOUR_UZLU(:,2)), abs(posuvy_vn_nap(:,2))) ;grid on;  %vykresli posuv horniho lice trhliny od napeti 1 MPa - z MKP
   xlim([0 4])
   set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - Vzdalenost od korene trhliny','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy (mm)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title( {'Posuv horniho lice trhliny od napeti 1 MPA'; 'pusobiciho na hranici telesa'},'FontName','times','FontSize',10,'FontWeight','bold');
   
subplot(2,3,2); plot(abs(SOUR_UZLU(:,2)), stress_opening(:)) ;grid on; %vykresli posuv horniho lice trhliny od napeti = napeti MPa - uvazujeme linearni narust posuvu s napetim
   xlim([0 4])
   set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy horniho lice (mm)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title( {['Posuv horniho lice trhliny od napeti ', num2str(napeti),'MPa']; ['pusobiciho na hranici telesa']},'FontName','times','FontSize',10,'FontWeight','bold');
   
subplot(2,3,3); plot(abs(SOUR_UZLU(:,2)), posuvy_isolforce(:,nod)) ;grid on; %vykresli posuv horniho lice trhliny zpusobeny isolovanou silou v prislusnem nodu NOD
   xlim([0 4])
   set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy (mm)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title( {'Posuv horniho lice od isol.sily'; ['pusobici v N=',num2str(nod),' nodu']},'FontName','times','FontSize',10,'FontWeight','bold');

for i=1:NN;
subplot(2,3,4); plot(abs(SOUR_UZLU(:,2)), posuvy_isolforce(:,i)) ;grid on; hold on; %vykresli posuv horniho lice trhliny zpusobeny isolovanou silou v prislusnem nodu NOD
end;  
   hold off;
   xlim([0 4])
   set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy (mm)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title( {'Posuv horniho lice od isol.sil'; 'pusobicich postupne ve vsech uzlech'},'FontName','times','FontSize',10,'FontWeight','bold');
   
subplot(2,3,5); plot(abs(SOUR_UZLU(:,2)), abs(bridgeposuv(:))) ;grid on;
   xlim([0 4])
   set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy (mm)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title( {'Posuv horniho lice - '; 'od premosteni'},'FontName','times','FontSize',10,'FontWeight','bold');

subplot(2,3,6); plot(abs(SOUR_UZLU(:,2)), aproxopening(:)) ;grid on;
   xlim([0 4])
   set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy (mm)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   title( {'Vysledn posunut horniho lice trhliny'; 's uvenm vlivu pemostni(zateno na hranici)'},'FontName','times','FontSize',10,'FontWeight','bold');
   

figure(2)
%zde se vykresli graf po cele delce trhliny - 0-4 mm
subplot(1,2,1);   %udela se obrazek se dvema grafy v radku - tohle bude prvni z nich
    plot(abs(SOUR_UZLU(:,2)), stress_opening(:),'Color','b','LineWidth',4);   hold on; %vykresli posuv horniho lice trhliny od napeti = napeti MPa - uvazujeme linearni narust posuvu s napetim
    plot(abs(SOUR_UZLU(:,2)), bridgeposuv(:),   'Color','r','LineWidth',2);   hold on; %vykresli vliv premosteni na posuvu horniho lice
    plot(abs(SOUR_UZLU(:,2)), aproxopening(:),  'Color','g','LineWidth',2);   hold on; %vykresli vysledne posunuti horniho lice s uvazenim vlivu premosteni
    plot(abs(SOUR_UZLU(:,2)), stress_opening(:)-bridgeposuv(:),  'Color','k','LineWidth',1,'marker','n');   hold on;
   grid on;
   xlim([0 4])
   set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy horniho lice [mm]'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   legend(['OPENING VN.NAPETI=', num2str(napeti),'MPa'],'VLIV PREMOSTENI','VYSLEDNE OTEVRENI TRHLINY',3,'Location','NorthWest');
   hold off;
%zde se vykresli graf v male oblasti okolo korene trhliny (dano v x-lim)
subplot(1,2,2);   %udela se obrazek se dvema grafy v radku - tohle bude druhy z nich
    plot(abs(SOUR_UZLU(:,2)), stress_opening(:),'Color','b','LineWidth',2);   hold on; %vykresli posuv horniho lice trhliny od napeti = napeti MPa - uvazujeme linearni narust posuvu s napetim
    plot(abs(SOUR_UZLU(:,2)), bridgeposuv(:),   'Color','r','LineWidth',2);   hold on; %vykresli vliv premosteni na posuvu horniho lice (zavreni od premosteni)
    plot(abs(SOUR_UZLU(:,2)), aproxopening(:),  'Color','g','LineWidth',2);   hold on; %vykresli vysledne posunuti horniho lice s uvazenim vlivu premosteni
    plot(abs(SOUR_UZLU(:,2)), stress_opening(:)-bridgeposuv(:),  'Color','k','LineWidth',1,'marker','n');   hold on;
   grid on;
   xlim([0 0.25])  
   %set(gca,'xtick',[0 0.5 1 1.5 2 2.5 3 3.5 4])
   xlabel('Vzdalenost od korene trhliny - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy horniho lice [mm]'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   legend(['OTEVRENI OD VN.NAPETI=', num2str(napeti),'MPa'],'VLIV PREMOSTENI','VYSLEDNE OTEVRENI TRHLINY',3,'Location','NorthWest');
   hold off;

 %for i=1:length(aproxopening);
 %    sigmabridge(i) = beta*sqrt(bridgeposuv(i)) * exp (- ( ( beta*sqrt(bridgeposuv(i)) /(  cf  *   Sigma)))^(mm+1)) + cf * (TAU * (h-bridgeposuv(i))* 2  /(R)) * ( 1 - exp(- ( ( beta*sqrt(bridgeposuv(i)) /(  cf  *   Sigma)))^(mm+1)));
  %sigmabridge(i)= beta *  sqrt(aproxopening(i));   %zde se vypocita z posuv mostici napeti
 %  if (sigmabridge(i) > pevnostvlaken) ; sigmabridge(i) = 0 ; end;    %podmnka je-li mostici napeti vypocetne v predchozim kroku vetsi nez pevnost vlaken, pak se nastavi na hodnotu nula (vlakna sou pretrzena a nic se tedy potom uz nenese)
 %end;
for i=1:NN;
 sigmabridge(i)= bridgestr(i,pocet_iteraci,index);
end;
   
%**********************************************************************
%*********** V Y P O C E T   H_br *************************************
%**********************************************************************

%***********************************************
% V nasledujicim se vypocte vahova funkce W(x,a)=h(x,a)
%***********************************************

 funkceW(:,1)=abs(SOUR_UZLU(:,2));
 funkceW(:,2)=GSIFbridge(:);      %Funkce funkceh je vahova funkce vstupujici do integralu pro K_bridge
%***********************************************
for i=1:NN;
 integrand(i)=funkceW(i,2)*sigmabridge(i);    %spocita hodnotu integrandu v integralu
end;
%**************************************************

%**************************************************
%*** Vytvoreni tabulky pro integraci **************
%**************************************************
integracnitab(:,1)=abs(SOUR_UZLU(:,2));   %vytvori promennou integracni tabulka, ktera bude obsahovat udaje pro integraci (prvni sloupec budou souradnice uzlu a v druhem funkcni hodnota samotneho integralu)
integracnitab(:,2)=integrand(:);
%**************************************************

XX=integracnitab;   %pouze pro zjednoduseni zapisu pri integraci zkratime promennou integracni tabulka na XX

%**************************************************
%*** Integrace Hbr Simpsonovou metodou ************
%**************************************************
%Nyni se pristoupi k vpotu Kbridge - pomoci integralu 
pruchod=0; 
K_bridge=0;
for i=1:2:length(integracnitab)-2,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     K_bridge = K_bridge + (((XX(i+2,1)-XX(i,1))/6) * (XX(i,2) + 4*XX(i+1,2) + XX(i+2,2)));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod=pruchod+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%*******************************************************
%***Integrace nejjednodussim obdelnikovym pravidlem***** (Pouze kontrola)
%*******************************************************
pruchod2=0; 
K_bridge2=0;
for i=1:length(integracnitab)-1,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     K_bridge2 = K_bridge2 + (((XX(i+1,1)-XX(i,1))/2) * (XX(i+1,2) +  XX(i,2)));    %Vypocet integralu na krivce C3 (vzdaleny od korene)     
     pruchod2 = pruchod2 +1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%*******************************************************

K_bridge=K_bridge*10^(-3) ;       %Prenasobi hodnotu soucinitele premosteni hodnotou 10^-3 - kvli jednotkam
K_bridge2=K_bridge2*10^(-3);

Stress_Kbridge_tab(1,2)=0 ; Stress_Kbridge_tab(1,3)=0;  %hodnoty K-bridge pro napeti 0 se nastavi na nulu (jinak je tam NAN)

%**************************************************
%*** V Y K R E S L E N I    H O D N O T ***********
%**************************************************
%nasledujici PLOT vykresli zavislosti GSIFbridge odpovidajc urcite poloze
%izolovanych sil
figure(12),
 subplot(2,2,1); plot(abs(SOUR_UZLU(:,2)), GSIFbridge_inf(:),'Color','b','marker','n','LineWidth',2); hold off; grid on;
   xlim([0 4]) 
   xlabel('Vzdalenost od korene trhliny [mm]','FontName','times','FontSize',13,'FontWeight','bold'), 
   ylabel('H_i_s_o_l_F - (MPa*m^\delta)'  ,'FontName','times','FontSize',13,'FontWeight','bold'),   
   nazevgrafu1=['Prubeh H_i_s_o_l_F od dvojice izolovanych sil v zavislosti '];  %prvni radek nazvu grafu
   nazevgrafu2=['na vzdalenosti techto sil od korene (MPa*m^\delta)'];        %druhy radek nazvu grafu
   nazevgrafu3=['(vahova funkce h(x,a)'];        %treti radek nazvu grafu
   title({nazevgrafu1,nazevgrafu2,nazevgrafu3},'FontName','times','FontSize',12,'FontWeight','bold'), 

 subplot(2,2,2); plot(abs(SOUR_UZLU(:,2)), sigmabridge(:),'Color','r','marker','n','LineWidth',2); hold off; grid on;
   xlim([0 4]) 
   xlabel('Vzdalenost od korene trhliny [mm]','FontName','times','FontSize',13,'FontWeight','bold'), 
   ylabel('Mostici napeti'  ,'FontName','times','FontSize',13,'FontWeight','bold'),   
   nazevgrafu1=['Mostici napeti pri zatizeni vnejsim napetim '];  %prvni radek nazvu grafu
   nazevgrafu2=['o hodnote MPa='];        %druhy radek nazvu grafu
   title({nazevgrafu1,[nazevgrafu2,num2str(napeti)]},'FontName','times','FontSize',12,'FontWeight','bold'),  
 
 subplot(2,2,3); plot(integracnitab(:,1),integracnitab(:,2),'Color','g','marker','n','LineWidth',2); hold off; grid on;
   xlim([0 4]); %ylim([0 max(integracnitab(:,2))]) 
   xlabel('Vzdalenost od korene [mm]','FontName','times','FontSize',13,'FontWeight','bold'), 
   ylabel('Hodnota integrandu'  ,'FontName','times','FontSize',13,'FontWeight','bold'),   
   nazevgrafu1=['Hodnota integrandu h(a,x)*Sigmabridge '];  %prvni radek nazvu grafu
   nazevgrafu2=['Integral=H_b_r= '];  %prvni radek nazvu grafu
   %nazevgrafu2=['o hodnote MPa='];        %druhy radek nazvu grafu
   title({nazevgrafu1,[nazevgrafu2,num2str(K_bridge)]},'FontName','times','FontSize',12,'FontWeight','bold'),  
  %set(gca,'xtick',[0 0.5-4 -3.5 -3 -2.5 -2 -1.5 -1 -0.5 0])
  %set(gca,'ytick',[0.5 0.6 0.7 0.8 0.9 1 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2 2.1 2.2 2.3 2.4 2.5])
  %legend('K-bridge nekonecne teleso','K-bridge konecne teleso','K-bridge-nekon / K-bridge-kon',3,'Location','NorthWest');
 hold off;

 
%u nasledujicich promennych je 2:NN+1 protoze chci aby prvni hodnota v
%kazdem radku sloupci posuv byla hodnota nula
%byly hodnoty nula
stress_openings(2:NN+1,index,1) = stress_opening(:);    %do teto promenne se ukladaji v jednotlivych krocich do jednotlivych sloupecku hodnoty otevreni od prislusneho vnejsiho napeti
bridgeposuvs   (2:NN+1,index,1) = bridgeposuv(:)   ;    %do kazdeho sloupecku teto matice se ulozi hodnoty posuvu od premosteni
aproxopenings  (2:NN+1,index,1) = aproxopening(:)  ;    %
integrands     (2:NN+1,index,1) = integrand(:);         %tabulka integrandu - funkci ktere se budou integrovat
Stress_Kbridge_tab(index+1,1,1) = napeti;       %do promenne Stress_Kbridge_tab  se ulozi do prvniho sloupce hodnoty napeti pro ktere se vypocty provadeli  (je tam +1, protoze na prvnim radku je nula)
Stress_Kbridge_tab(index+1,2,1) = K_bridge;     %do promenne Stress_Kbridge_tab  se ulozi do druheho sloupce hodnoty K_bridge integrovane simsonovou metodou
Stress_Kbridge_tab(index+1,3,1) = K_bridge2;    %do promenne Stress_Kbridge_tab  se ulozi do tretiho sloupce hodnoty K_bridge integrovane druhou metodou (pouze kontrolni sloupec)
Stress_Kbridge_tab(index+1,4,1) = (GSIFappl/ZATIZENI)*step;    %do promenne Stress_Kbridge_tab  se ulozi do ctvrteho sloupce hodnoty K_aplikovane - linearni narust  - (pro 100 MPA je jeho hodnota 6,6, pro 1MPA je to 0.066)

index=index+1
end;
 
%modifikace=modifikace+1  %modifikace je promenna, ktera urcuje pro kterou hodnotu pevnosti vlaken nebo weibullova modulu mm pocitame premosteni - 2000, 2300, 2600 MPA nebo mm = 3 nebo 6
%end;
%modifikace=modifikace-1;  %odecte se jednicka, protoze pri poslednim pruchodu se pricetla navic
%save('Vars_Kbridge_vytahovani_WF_zmena_pevnostivlaken');  %ulozi cely workspace do souboru Vars_Kbridge v pracovnim adresari (vsechny promenne)
%  saveas(figure(12),f5,'fig')
%  saveas(figure(12),f5,'jpg') 

 %**************************************************************************
%**** Do obrzku 14 se nakresli otevreni od premosteni a nepremostene trhliny - specialne do clanku
    %**************************************************************************
    SOUR_UZLU(2:NN+1,2) = SOURuzlu(1:NN);  %udela v promenne SOUR_UZLU na prvnim radku nulu - tj ze souradnice prvniho uzlu (korene trhliny) bude nula

    index=100; %zadme natvrdo kterou hodnotu napeti chceme vykreslit (index - 0-150 (nebo dle zadani v cyklu ve)
     figure(14)
     polpopisku=max(bridgestr(:,200,index))/2;   %popisek se napise v grafu do poloviny maximalniho hodnoty otevreni
       for index=100:100;
          h = plot((SOUR_UZLU(2:NN+1,2)), bridgestr(:,200,index),'Color','r','LineWidth',2);   hold on; %vykresli posuv horniho lice trhliny od napeti = napeti MPa - uvazujeme linearni narust posuvu s napetim
       end; grid on; 
          h = plot([-4 0],[0 0] , 'Color','k','LineWidth',1), hold off  ;
        % xlabel('Vzdalenost od korene [mm]','FontName','times','FontSize',14,'FontWeight','bold'),    
        % ylabel('Posuv lice trhliny [mm]'  ,'FontName','times','FontSize',14,'FontWeight','bold'),  
          xlabel('Vzdalenost od korene trhliny [mm]','FontName','times','FontSize',14,'FontWeight','bold'),    
          ylabel('Mostici napeti [MPa]'  ,'FontName','times','FontSize',14,'FontWeight','bold'),  

          %title( {'Vnejsi napeti [MPa]'; num2str(Stress_Kbridge_tab(k,1)) },'FontName','times','FontSize',14,'FontWeight','bold');
          text(-3,polpopisku,['\sigma _a_p_p_l = ',num2str(Stress_Kbridge_tab(index-1,1,modifikace)),' MPa'],'FontSize',20,'FontWeight','bold');
         % text(-3,polpopisku/2,['H_b_r = ',num2str(Stress_Kbridge_tab(index-1,2,modifikace)),' MPa.m^1^-^\delta'],'FontSize',20,'FontWeight','bold');
         % legend('Unbridged crack opening','Bridging closure','Total crack opening',3,'Location','NorthWest');
    %      legend('Posuv lice nepremostene trhliny','Vliv premosteni','Posuv lice premostene trhliny',3,'Location','NorthEast');
          set(gca,'xlim',[-4 0],'Visible','on');  %'ylim',[0 0.12]
          set(gca,'xtick',[-4 -3.5 -3 -2.5 -2 -1.5 -1 -0.5 0])



 %**************************************************************************
%**** Do obrzku 11 se nakresli otevreni od premosteni a nepremostene trhliny - specialne do clanku
%**************************************************************************

index=23; %zadme natvrdo kterou hodnotu napeti chceme vykreslit (index - 0-150 (nebo dle zadani v cyklu ve)
 figure(11)
 polpopisku=max(stress_openings(:,index-1))/2;   %popisek se napise v grafu do poloviny maximalniho hodnoty otevreni
      h = plot((SOUR_UZLU(:,2)), stress_openings(:,index-1,1),'Color','b','LineWidth',4);   hold on; %vykresli posuv horniho lice trhliny od napeti = napeti MPa - uvazujeme linearni narust posuvu s napetim
      h = plot((SOUR_UZLU(:,2)), -bridgeposuvs(:,index-1,1),   'Color','r','LineWidth',2);  hold on; %vykresli vliv premosteni na posuvu horniho lice
      h = plot((SOUR_UZLU(:,2)), aproxopenings(:,index-1,1),  'Color','g','LineWidth',2);   hold on; %vykresli vysledne posunuti horniho lice s uvazenim vlivu premosteni
     grid on; 
      h = plot([-4 0],[0 0] , 'Color','k','LineWidth',1), hold on  ;
    % xlabel('Vzdalenost od korene [mm]','FontName','times','FontSize',14,'FontWeight','bold'),    
    % ylabel('Posuv lice trhliny [mm]'  ,'FontName','times','FontSize',14,'FontWeight','bold'),  
      xlabel('Vzdalenost od korene trhliny [mm]','FontName','times','FontSize',14,'FontWeight','bold'),    
      ylabel('Posuv horniho lice [mm]'  ,'FontName','times','FontSize',14,'FontWeight','bold'),  
 
      %title( {'Vnejsi napeti [MPa]'; num2str(Stress_Kbridge_tab(k,1)) },'FontName','times','FontSize',14,'FontWeight','bold');
      text(-3,polpopisku,['\sigma _a_p_p_l = ',num2str(Stress_Kbridge_tab(index-1,1,modifikace)),' MPa'],'FontSize',20,'FontWeight','bold');
      text(-3,polpopisku/2,['H_b_r = ',num2str(Stress_Kbridge_tab(index-1,2,modifikace)),' MPa.m^1^-^\delta'],'FontSize',20,'FontWeight','bold');
      legend('Otevreni nepremostene trhliny','Uzavreni od premosteni','Vysledne otevreni trhliny',3,'Location','NorthWest');
%      legend('Posuv lice nepremostene trhliny','Vliv premosteni','Posuv lice premostene trhliny',3,'Location','NorthEast');
      set(gca,'xlim',[-4 0],'Visible','on');  %'ylim',[0 0.12]
      set(gca,'xtick',[-4 -3.5 -3 -2.5 -2 -1.5 -1 -0.5 0])

%**************************************************************************
%**** Do obrzku 13 se nakresli zavislosti mosticiho, aplikovaneho a
%lokalni zobecneho SIF na velikosti vnejsiho napeti
%************************************************************************** 
figure(13);
    lstyle='--'
    plot(Stress_Kbridge_tab(:,1,1), Stress_Kbridge_tab(:,4,1), 'Color','b','LineWidth',3,'LineStyle','-'), hold on ;
    plot(Stress_Kbridge_tab(:,1,1), Stress_Kbridge_tab(:,2,1), 'Color','g','LineWidth',3,'LineStyle',lstyle), hold on  ;
    plot(Stress_Kbridge_tab(:,1,1), Stress_Kbridge_tab(:,4,1)-Stress_Kbridge_tab(:,2,1), 'Color','r','LineWidth',3,'LineStyle',lstyle), hold on ;

   hold off;
   xlabel('Aplikovan zatizeni [MPa]','FontName','Arial','FontSize',12,'FontWeight','bold'),    
   ylabel('Zobecnene SIF [MPa.m^1^-^\delta]'  ,'FontName','Arial','FontSize',12,'FontWeight','bold'),  
   legend('Aplikovany SIF H_a_p_p_l','Mostici SIF H_b_r','Lokalni SIF H_t_i_p = H_a_p_p_l - H_b_r',3,'Location','NorthWest');
   set(gca,'xlim',[0 150],'Visible','on','FontName','Arial','FontSize',12,'FontWeight','normal');
   set(gca,'xtick',[0 10 20 30 40 50 60 70 80 90 100 110 120 130 140 150])

   grid on;

    
%**************************************************************************    
PROVEST=1;

if PROVEST==1    
%**************************************************************************
%**** V nasledujicim se vytvori A N I M A C E prubehu premosteni v ********
%**************zavislosti na velikosti vnejsiho napeti ********************
%**************************************************************************
%*** Prvni subplot - prubeh otevreni trhliny  
%    Druhy subplot - Velikost K_bridge v zavislosti na velikosti napeti
%**************************************************************************

avigraf=figure(10),   
 set(avigraf,'DoubleBuffer','on' );   % nastavi vlastnosti objektu (doublebuffering je tam proto, aby pri prechodu na dalsi obrazek nevznikali prazdna mista pri prechodu na dalsi obrazek
 set(gca, 'NextPlot','replace','Visible','on');  %nastavi jak se maji chovat osy pri prekresleni dalsim obrazkem (replace-prekreslit) - visibility on - budou videt
 %set(gca,'xlim',[0 4],'ylim',[0 1], 'NextPlot','replace','Visible','on');   %nastavi se limity os (get current axis handle) - nextplot add znamena, ze se vzdy nasledujici obrazek nakresli do stejnych os
 grid on;  %zapne mku

if Br_Model=='1', jmenoanimace='H_bridge_simple_model'; end; 
if Br_Model=='2', jmenoanimace='H_bridge_advanced_model'; end;

animace = avifile(jmenoanimace,'quality',100,'fps',20,'compression','Indeo5');    %vytvori avi soubor s nazvem uvedenym v zavorce o kvalite nejvyssi 100 a 30 snimku za sekundu
crackindex=0;

for k=1:150%length(Stress_Kbridge_tab)-1  
     subplot(1,2,1);  %prvni SUBPLOT  
      h = plot(SOUR_UZLU(:,2), stress_openings(:,k,1),'Color','b','LineWidth',3);   hold on; %vykresli posuv horniho lice trhliny od napeti = napeti MPa - uvazujeme linearni narust posuvu s napetim
      h = plot(SOUR_UZLU(:,2), -bridgeposuvs(:,k,1),   'Color','r','LineWidth',2);   hold on; %vykresli vliv premosteni na posuvu horniho lice
      h = plot(SOUR_UZLU(:,2), aproxopenings(:,k,1),  'Color','g','LineWidth',3);   grid on;  hold on; %vykresli vysledne posunuti horniho lice s uvazenim vlivu premosteni
      h = plot([-4 0],[0 0] , 'Color','k','LineWidth',1), hold off  ;
      xlabel('Vzdalenost od korene trhliny [mm]','FontName','times','FontSize',12,'FontWeight','bold'),    
      ylabel('Posuv horniho lice trhliny [mm]'  ,'FontName','times','FontSize',12,'FontWeight','bold'),  
      %title( {'Vnejsi napeti [MPa]'; num2str(Stress_Kbridge_tab(k,1)) },'FontName','times','FontSize',14,'FontWeight','bold');
      text(-3.2,-0.12,['\sigma_a_p_p_l = ',num2str(Stress_Kbridge_tab(k,1,1)),' MPa'],'FontSize',18,'FontWeight','bold');
      legend('Otevreni nepremostene trhliny','Uzavreni od premosteni','Vysledne otevreni trhliny',3,'Location','SouthEast');
      set(gca,'xlim',[-4 0],'ylim',[-0.25 0.25],'Visible','on');
      set(gca,'xtick',[-4 -3.5 -3 -2.5 -2 -1.5 -1 -0.5 0])
      
     subplot(1,2,2); %druhy SUBPLOT 
       h = plot(Stress_Kbridge_tab(1:k,1,1), Stress_Kbridge_tab(1:k,4,1), 'Color','b','marker','x','MarkerSize',5,'LineWidth',2), hold on ; %vykresli vysledne posunuti horniho lice s uvazenim vlivu premosteni
       h = plot(Stress_Kbridge_tab(1:k,1,1), Stress_Kbridge_tab(1:k,2,1), 'Color','r','marker','x','MarkerSize',5,'LineWidth',2), hold on  ;
       h = plot(Stress_Kbridge_tab(1:k,1,1), Stress_Kbridge_tab(1:k,4,1)-Stress_Kbridge_tab(1:k,2,1), 'Color','g','marker','x','MarkerSize',5,'LineWidth',2), hold off ; grid on; 
      xlabel('Aplikovane napeti [MPa]','FontName','times','FontSize',12,'FontWeight','bold'),
      ylabel('Zobecnene SIF [MPa.m^1^-^\delta]'  ,'FontName','times','FontSize',12,'FontWeight','bold'),    
      legend('Aplikovany SIF H_a_p_p_l','Mostici SIF H_b_r','Lokalni SIF H_t_i_p=H_a_p_p_l-H_b_r',3,'Location','NorthWest');
      %title( {'K-bridge [MPa.m^delta]'; num2str(Stress_Kbridge_tab(k,2)) },'FontName','times','FontSize',14,'FontWeight','bold');
      popis = text(30,6.75, ['H_b_r= ',num2str(Stress_Kbridge_tab(k,2,1), '%10.2f'),' MPa.m^1^-^\delta'],'FontSize',15,'FontWeight','bold');
      popis2= text(30,7.5,  ['H_a_p_p_l= ',num2str(Stress_Kbridge_tab(k,4,1), '%10.2f'),' MPa.m^1^-^\delta'],'FontSize',15,'FontWeight','bold');
      popis3= text(30,6,    ['H_t_i_p= ',num2str(Stress_Kbridge_tab(k,4,1)-Stress_Kbridge_tab(k,2,1), '%10.2f'),' MPa.m^1^-^\delta'],'FontSize',15,'FontWeight','bold');
      %nasledujici podminka zjisti pri jakem napeti dojde k pretrzeni
       %prvnich vlaken a tam se umisti v druhem SUBPLOTU popisek
       if (Stress_Kbridge_tab(k,2,1) > Stress_Kbridge_tab(k+1,2,1))& (crackindex==0)    
          crackindex(1)=k;     %index udaji v matici Stress_Kbridge_tab pro ktery dojde k pretrzeni vlaken
          crackindex(2)=Stress_Kbridge_tab(k,1,1);  %hodnota napeti pri kterem se poprve porusi vlakna
          crackindex(3)=Stress_Kbridge_tab(k,2,1);  %hodnota Kbridge ktera nastane pri prvnim poruseni vlaken
       end
%       if (crackindex(1)~=0)    %not equal
%          pozX = Stress_Kbridge_tab(crackindex(1),1); pozY= Stress_Kbridge_tab(crackindex(1),2);   %x-ova a Y-ova pozice umisteni popisku v obrazku 
%          popisek_pretrzeni = text(pozX,pozY,[{'\leftarrow Brakeage of first fibers',['        (',num2str(crackindex(2),'%10.0f'),' MPa)']}] ,'FontSize',12,'FontWeight','bold','HorizontalAlignment','Left' );   %,'HorizontalAlignment','Left' 
%       end
     
       set(gca,'xlim',[0 150],'ylim',[0 10],'Visible','on');
       set(gca,'xtick',[0 10 20 30 40 50 60 70 80 90 100 110 120 130 140 150])
      %set(popis,'EraseMode','normal');
    
      set(h,'EraseMode','none');                       %mode pro vymazani
      set(figure(10),'Position',[200 200 1000 528]);   %Parametr Position udava v hranatych zavorkach - pozici okna a jeho velikost 
      F = getframe(gcf);                               %udela se snimek celeho figure (vcetne popisku os) -gcf (figure) - gca (jenom obsah grafu)
      animace = addframe(animace,F);                   %do promenne animace se prida dalsi snmek
  end;
animace = close(animace);              %uzavre avi soubor uvedeny v zavorce pro editaci
    

end;