%*************************************************************
%*  Ing. OLDICH EVEEK v rmci projetku FRV 2421/2007/G1 *
%*************************************************************

clear all,
%function [Bsel,GSIF,PSI_INT_C2b] = Importdat_newSS(poradidelta)
%poradidelta=poradidelta;
%poloh=poloh;
poradidelta=1;  %toto je promenna, ktera udava, ktere delta uvazujeme (1 - uvazujeme delta z intervalu(0,1) ; 2 - uvazujeme delta z intervalu (1,2) (podle toho se pak meni v souboru singularsol vstupni soubor z MAPLU

%Tento soubor nacte hodnoty z ansysu, vypocita hodnoty pomocneho reseni
%pomoci m-filu singularsol (pro prislusne uhly odpovidajici uhlum nodu z ansysu a nasledne tyto dve hodnoty spolu pro integruje
%na integracni ceste RC2
%**************************************************************************
%Tento soubor jiz predpoklada ze data z ansysu tedy i model v ansysu jsou v
%souradnem systemu pouziteho pri vypoctech v MAPLU

%******* I N P U T   O B L A S T *****************************************
%POZN: integracni polomer se nacita primo z txt souboru ansysu - je tam
%ulozenen ve sloupci SOURR-4. sloupec. - viz radek 37 (hodnoty v metrech)
alfa=0;              %uhel trhliny od zaporne osy X
FI=0;                %rozevreni trhliny
R4=1;                % (mm)   
INV_EPS=100;         %prevracena hodnota epsilon (defakto kolikrat je mensi prirustek nez polomer R4) - uzivame prevracenou hodnotu, jelikoz je to vyhodnejsi pro nazev souboru
%Tstress=-7.3;

%******* D O P O C I T A N E   H O D N O T Y *****************************
EPSI=1/INV_EPS ;         % hodnota pomeru l/R - epsilon
alfa1=180+alfa ;         % uhel od kladne osy x k ose vrubu (trhliny)
FI1=alfa1-FI/2 ;         % uhel od kladne osy x k prvnmu celu vrubu (trhliny)
FI2=alfa1+FI/2 ;         % uhel od kladne osy x k druhemu celu vrubu (trhliny)

%**************************************************************************
predponasouboru='';  %GPS - generalized plain strain

%***** N A C T E  S E   S O U B O R   Z   P O L O H A M I   U Z L U   N A  O U T E R  D O M A I N
filename4=['Uzly_na_OuterDomain_proALFA=',num2str(alfa),'_FIopen=',num2str(FI),'.txt'];  %'_opacnematerialy',
f4 = fullfile('MKPdata', filename4)  %prikaz ktery vytvori komplet cestu k danemu souboru
%filename2=['hodnoty_uzlu_pro_R=',num2str(poloh),'.txt'];  %
%f2 = fullfile('D:', 'Ansys', 'matlab work','work','MKPdata_prubehyGSIF', filename2)  %prikaz ktery vytvori komplet cestu k danemu souboru
fid=fopen(f4,'r');
%nacteme prvni serii dat (mezi prvni a druhou hlavickou)  
D = textscan(fid, '%f %f %f %f', 'headerlines', 1)  %37 znamena kolik radku se ma cist, 11 znamena kolik radku vynechat
% SOURR   SOURFI    SOURFItr    OBLAST     
%- zde jsou pouze tri oblasti (dolni celo-rozhrani ; rozhrani -rozhrani ; rozhrani horni celo)
fclose(fid)       %uzavre soubor pro cteni

COORUZLU = cell2mat(D);   %cell2mat (prevede CELL na obycejnou matici)
COORUZLUsort=sortrows(COORUZLU,[3,4]);   %setridi matici COORUZLU nejdrive podle tretiho sloupce a potom podle ctvrteho (prislusnost k dane oblasti)


GSIF=1  %nastavime GSIF na hodnotu 1 abychom to meli jednotkove a mohli ho potom vytknout z integralu
%********************************************************************************   
%      V y p i s   p o s u v u    v   u z l e c h   n a c t e n y c h   z M K P 
%********************************************************************************
%Zde se vypisou pro jednotlive polarni souradnice uzlu hodnoty posuvu ze
%singularniho reseni (nezahrnujiciho vliv T-napeti) - je jiz prenasobeno
%Kfaktorem

R4=COORUZLU(1,1)*10^-3;    %polomer se prevede na metry (je to potreba do vypoctu singularniho reseni

for t=1:length(COORUZLU),
    uheltheta=COORUZLUsort(t,3); %Bsel(t,1);  %zde se v tomto cyklu vypoctou hodnoty singularniho reseni na polomeru 1
  [UXsin,UYsin,SXsin,SYsin,SXYsin,delta] = SingularSolution(uheltheta,R4,2,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
    COORUZLUsort(t,5) = GSIF * UXsin *10^3;   %do 5. sloupecku se ulozi UX singularniho reseni (mm)  **10^3 protoze v ansysu se zadavaji milimetry
    COORUZLUsort(t,6) = GSIF * UYsin *10^3;   %do 6. sloupecku se ulozi UY singularniho reseni (mm)
    COORUZLUsort(t,7) = COORUZLUsort(t,3)-90;     %do 7. sloupecku se ulozi uhly s uhlovym pocatkem na ose x
    COORUZLUsort(t,8) = GSIF * SXsin;         %do 8. sloupecku se ulozi SX singularniho reseni (MPa) 
    COORUZLUsort(t,9) = GSIF * SYsin;         %do 9. sloupecku se ulozi SY singularniho reseni (MPa)
end;
% V nasledujicim cyklu se prepocita napeti v danych uzlech na izolovane sily, ktere jiz lze zadavat v ansysu (prvni a posledni uzel se v tomto cyklu vynecha
R4=COORUZLU(1,1);    %polomer R4 se opet nastavi na milimetry
for t=2:length(COORUZLUsort)-1;
    S = R4*pi/180* ( (COORUZLUsort(t+1,7)-COORUZLUsort(t,7))/2 + (COORUZLUsort(t,7)-COORUZLUsort(t-1,7))/2 );
    COORUZLUsort(t,10) = S;   %do 10. sloupecku se ulozi plocha prislusna danemu uzlu (celkova) (vzdy pulka predchozi a pulka nasledujici delky elementu)
    COORUZLUsort(t,11)= S * cosd(COORUZLUsort(t,7));  %do 11. sloupecku se ulozi plocha prislusna danemu uzlu (prumet kolmy na osu X)
    COORUZLUsort(t,12)= S * sind(COORUZLUsort(t,7));  %do 12. sloupecku se ulozi plocha prislusna danemu uzlu (prumet kolmy na osu Y)
    COORUZLUsort(t,13)= COORUZLUsort(t,8) * COORUZLUsort(t,11);   %do 13. sloupecku se ulozi sila FX aplikovana do daneho uzlu
    COORUZLUsort(t,14)= COORUZLUsort(t,9) * COORUZLUsort(t,12);   %do 14. sloupecku se ulozi sila FY aplikovana do daneho uzlu
end;

%Vpoet sly v prvnim uzlu - na dolnim cele
  S = R4*pi/180* ( (COORUZLUsort(2,7)-COORUZLUsort(1,7))/2);
  COORUZLUsort(1,10) = S;   %do 10. sloupecku se ulozi plocha prislusna danemu uzlu (celkova)
  COORUZLUsort(1,11)= S * cosd(COORUZLUsort(1,7));  %do 11. sloupecku se ulozi plocha prislusna danemu uzlu (prumet kolmy na osu X)
  COORUZLUsort(1,12)= S * sind(COORUZLUsort(1,7));  %do 12. sloupecku se ulozi plocha prislusna danemu uzlu (prumet kolmy na osu Y)
  COORUZLUsort(1,13)= COORUZLUsort(1,8) * COORUZLUsort(1,11);   %do 13. sloupecku se ulozi sila FX aplikovana do daneho uzlu
  COORUZLUsort(1,14)= COORUZLUsort(1,9) * COORUZLUsort(1,12);   %do 14. sloupecku se ulozi sila FY aplikovana do daneho uzlu

%Vpoet sly v prvnim uzlu - na dolnim cele
 konec=length(COORUZLUsort);
 S = R4*pi/180* ( (COORUZLUsort(konec,7)-COORUZLUsort(konec-1,7))/2);
  COORUZLUsort(konec,10) = S;   %do 10. sloupecku se ulozi plocha prislusna danemu uzlu (celkova)
  COORUZLUsort(konec,11)= S * cosd(COORUZLUsort(konec,7));  %do 11. sloupecku se ulozi plocha prislusna danemu uzlu (prumet kolmy na osu X)
  COORUZLUsort(konec,12)= S * sind(COORUZLUsort(konec,7));  %do 12. sloupecku se ulozi plocha prislusna danemu uzlu (prumet kolmy na osu Y)
  COORUZLUsort(konec,13)= COORUZLUsort(konec,8) * COORUZLUsort(konec,11);   %do 13. sloupecku se ulozi sila FX aplikovana do daneho uzlu
  COORUZLUsort(konec,14)= COORUZLUsort(konec,9) * COORUZLUsort(konec,12);   %do 14. sloupecku se ulozi sila FY aplikovana do daneho uzlu


% V nasledujicim se vytvori soubor kam se zapisi prikazy do ansysu
% predepisujici v jednotlivych uzlech posuvy UX a UY

filename5=['Posuvy_uzlu_na_OD_proALFA=',num2str(alfa), '_FIopen=',num2str(FI),'.txt'];  %'_opacnematerialy',

f5 = fullfile('MATLABdata', filename5)  %prikaz ktery vytvori komplet cestu k danemu souboru
fid=fopen(f5,'wt');  %otevre soubor s nazvem f5 a format souboru bude WRITE TEXT

%**************************************************************************
%***** I. O B L A S T  (od dolniho cela trhliny po rozhrani) **************
%**************************************************************************
i=1;   %index, ktery se bude projizdet se nastavi na jednicku
fprintf(fid,'GSIF= %g\n',GSIF);  %do prvniho radku se zapise hodnota zobecnnho souinitele intensity napeti (nacte se do ansysu a pak zpet do matlabu do souboru integrace
fprintf(fid,'!********************************************************************************\n');
fprintf(fid,'!***** Okrajove podminky v I. OBLASTI  (dolni celo trhliny-rozhrani) ************\n');
fprintf(fid,'!********************************************************************************\n');

while COORUZLUsort(i,4)==1        %dokud je ve 4.sloupci 1 (tj jedna se o oblast 1) tak se budou provadet nasledujici prikazy
   %   for i=1:length(COORUZLUsort),
     fprintf(fid,'CSYS,1   $ ASEL,S,LOC,Y,0,FI2-270  $  NSLA,S,1\n');
     fprintf(fid,'NSEL,R,LOC,X, %g',COORUZLUsort(i,1)) ;     %string $ znamena ze to bude prikaz na jednom radku - prikazy se timto znakem oddeluji - jako byly kazdy na zvlastnim radku
     fprintf(fid,'   $  NSEL,R,LOC,Y, %g',COORUZLUsort(i,2)) ;  % %g znamena, ze misto toho bude cislo uvedene za carkou (muze byt i vice cisel -vzdy se oddeluji carkou)
     fprintf(fid,'   $  CSYS,0');   
     fprintf(fid,'   $  D,ALL,UX, %g'  ,COORUZLUsort(i,5)) ;  
     fprintf(fid,'   $  D,ALL,UY, %g\n',COORUZLUsort(i,6)) ;    %\n znamena ze dalsi prikazy budou na novem radku
 
  i=i+1;
end;

%**************************************************************************
%***** II. O B L A S T  (od dolniho cela trhliny po rozhrani) *************
%**************************************************************************
fprintf(fid,'!*************************************************************************************\n');
fprintf(fid,'!****** DOSUD BYLO PREDEPSANO CELKEM  %g z %g  UZLU v ROZMEZI  UHLU  %g az %g  \n',i-1,length(COORUZLUsort), FI2-270 ,0);
fprintf(fid,'!*************************************************************************************\n');
fprintf(fid,'!***** Okrajove podminky v II. OBLASTI  (rozhrani-rozhrani (v substratu)) ************\n');
fprintf(fid,'!*************************************************************************************\n');

while COORUZLUsort(i,4)==2           %dokud je ve 4.sloupci 2 (tj jedna se o oblast II) tak se budou provadet nasledujici prikazy
   %   for i=1:length(COORUZLUsort),
     fprintf(fid,'CSYS,1   $ ASEL,S,LOC,Y,0,180  $  NSLA,S,1\n');
     fprintf(fid,'NSEL,R,LOC,X, %g',COORUZLUsort(i,1)) ;     %string $ znamena ze to bude prikaz na jednom radku - prikazy se timto znakem oddeluji - jako byly kazdy na zvlastnim radku
     fprintf(fid,'   $  NSEL,R,LOC,Y, %g',COORUZLUsort(i,2)) ;  % %g znamena, ze misto toho bude cislo uvedene za carkou (muze byt i vice cisel -vzdy se oddeluji carkou)
     fprintf(fid,'   $  CSYS,0');   
     fprintf(fid,'   $  D,ALL,UX, %g'  ,COORUZLUsort(i,5)) ;  
     fprintf(fid,'   $  D,ALL,UY, %g\n',COORUZLUsort(i,6)) ;    %\n znamena ze dalsi prikazy budou na novem radku
  i=i+1;
end;

%**************************************************************************
%******* III. O B L A S T  (od dolniho cela trhliny po rozhrani) **********
%**************************************************************************
fprintf(fid,'!**************************************************************************************\n');
fprintf(fid,'!****** DOSUD BYLO PREDEPSANO CELKEM  %g z %g  UZLU v ROZMEZI  UHLU  %g az %g  \n',i-1,length(COORUZLUsort), 0 ,180);
fprintf(fid,'!**************************************************************************************\n');
fprintf(fid,'!***** Okrajove podminky v III. OBLASTI  (rozhrani-rozhrani (v substratu)) ************\n');
fprintf(fid,'!**************************************************************************************\n');

 for k=i:length(COORUZLUsort),                    %tento cyklus projede zbytek tabulky COORUZLUsort (jiz obsahujici ve 4.sloupci pouze cislo 4
     fprintf(fid,'CSYS,1   $ ASEL,S,LOC,Y,180,FI1+90  $  NSLA,S,1\n');
     fprintf(fid,'NSEL,R,LOC,X, %g',COORUZLUsort(k,1)) ;     %string $ znamena ze to bude prikaz na jednom radku - prikazy se timto znakem oddeluji - jako byly kazdy na zvlastnim radku
     fprintf(fid,'   $  NSEL,R,LOC,Y, %g',COORUZLUsort(k,2)) ;  % %g znamena, ze misto toho bude cislo uvedene za carkou (muze byt i vice cisel -vzdy se oddeluji carkou)
     fprintf(fid,'   $  CSYS,0');   
     fprintf(fid,'   $  D,ALL,UX, %g'  ,COORUZLUsort(k,5)) ;  
     fprintf(fid,'   $  D,ALL,UY, %g\n',COORUZLUsort(k,6)) ;    %\n znamena ze dalsi prikazy budou na novem radku
 end;
 fprintf(fid,'!************************************************************************************\n');
 fprintf(fid,'!****** DOSUD BYLO PREDEPSANO CELKEM  %g z %g  UZLU v ROZMEZI  UHLU  %g az %g  \n',k,length(COORUZLUsort), 180 ,FI1+90);
 fprintf(fid,'!************************************************************************************\n');
 fprintf(fid,'ALLSEL,ALL\n');

fclose(fid)  %uzavre soubor s oznacenim fid pro zapis


