%*************************************************************
%*  Ing. OLDICH EVEEK v rmci projetku FRV 2421/2007/G1 *
%*************************************************************

function [UXpom,UYpom,SXpom,SYpom,SXYpom,delta] = singularsolnewSS(uheltheta,polomer,pomocnereseni,poradidelta)
%clear all;
%nasledujici hodnoty jsou pro SS ansysu.
SS=1 ; %Souradny System = 1 - MAPLE, 2 - ANSYS

%**zde se v nasledujicim zvoli prislusny vstupni soubor pro nacitani
%hodnot z maplu (v zavislosti na tom pro jake delta chceme pocitat napeti.
if (poradidelta==1)
   vl_vektory_z_maplu;   %tento prikaz spusti script z MAPLU obsahujici ciselne hodnoty jednotlivych matic. %delta  =  0.328; %deltaS = -0.328
end;
%**********************************

pomocnereseni=pomocnereseni; %1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni

r=polomer;  %vzdalenost od stredu na ktere hledame napeti a posuvy

uheltheta = uheltheta -90; %od uhlu THETA odecteme devadesat stupnu, protoze pocatek integracni cesty neni na svisle osy x, ale na spodnim cele trhliny (-90 stupnu)

%odsud je jiz uheltheta v SS X dolu Y vodorovne doprava
theta = uheltheta * pi/180;    %prevede uhel ze stupnu na radiany

% j- znamen imaginarni jednotku

%********   O  B  L  A  S  T   (I)  ****************************** (-pi/2,0)
if ((uheltheta <= 0) && (uheltheta >= -90))

%jednicka za podtrzitkem znamena oblast na materialu
     AI = 10^0*[ A11_1 , A12_1 ; A21_1 , A22_1];   %matici A nasobime 10^6 aby mela rozmerMPa - jiz nemusime - jiz z MAPLU jdou hodnoty v MPa - proto 10^0
%***
     LI = [ L11_1 , L12_1 ; L21_1 , L22_1];
%***           
  LphiI = [Lphi1_1 ; Lphi2_1] ;
%***
   mi1I = mi1_1;
   mi2I = mi2_1;
 MI_I=[mi1_1,0; 0,mi2_1];       %diagonalni matice - na diagonale jsou mi1, mi2 pro oblast I
%***
LphiSI =[LphiS1_1 ; LphiS2_1];	%vlastn vektor u_pom - odpovdajc pomocnmu een

%v pripade ze chceme spocitat singularni reseni musi byt promenna rovna 2
if pomocnereseni==2
deltaS=delta; LphiSI=LphiI; %tento radek udela z pomocneho reseni singularni
end;

e=[(cos(theta)+mi1I*sin(theta))^(deltaS-1),0; 0,(cos(theta)+mi2I*sin(theta))^(deltaS-1)];
e2=[mi1I*(cos(theta)+mi1I*sin(theta))^(deltaS-1),0; 0,mi2I*(cos(theta)+mi2I*sin(theta))^(deltaS-1)];
e_p=[(cos(theta)+mi1I*sin(theta))^(deltaS),0; 0,(cos(theta)+mi2I*sin(theta))^(deltaS)];  %matice e definovana pro posuvy - je umocneno na deltaS

eCONJ= [(cos(theta)+conj(mi1I)*sin(theta))^(deltaS-1),0; 0,(cos(theta)+conj(mi2I)*sin(theta))^(deltaS-1)];
PHI=   delta  * [-mi1I*Lphi1_1 , Lphi1_1  ; -mi2I*Lphi2_1 , Lphi2_1 ];
PHI_S= deltaS * [-mi1I*LphiS1_1, LphiS1_1 ; -mi2I*LphiS2_1, LphiS2_1];

%*** Vpoet posuv pomocnho een****
posuvyI =  r^deltaS    * ( ( AI *  e_p * inv(LI) * LphiSI )  +  ( conj(AI)* conj(e_p) * inv(conj(LI))* conj(LphiSI) ) );

%*** Vpoet napt pomocnho een ****
SIGMAIA= -r^(deltaS-1) *  ( LI * deltaS * (e * MI_I) * inv(LI) * LphiSI + conj(LI) * deltaS * conj(e * MI_I) * conj(inv(LI))* conj(LphiSI)) ;
SIGMAIB=  r^(deltaS-1) *  ( LI * deltaS *  e         * inv(LI) * LphiSI + conj(LI) * deltaS * conj(e)        * conj(inv(LI))* conj(LphiSI)) ;

NAPETI_I(1,:)=SIGMAIA;  NAPETI_I(2,:)=SIGMAIB;  %zde se vytvori ze dvou vektoru jedna matice
NAPETI_I;   %vypise matici napeti v danem bode - na polomeru r a uhlu theta

 
%ZDE ZUSTANOU POSUVY NAPETI V SS MAPLU
 UXpom= 10^0 * (posuvyI(1))    ; UYpom= 10^0 * (posuvyI(2));   %nasobime 10^3 abychom prevedli m na mm
 SXpom= 10^0* (NAPETI_I(1,1)) ; SYpom= 10^0* (NAPETI_I(2,2))  ;  SXYpom= 10^0 * (NAPETI_I(2,1));  %nasobime 10^-6 abychom prevedli Pa na MPa
 
%*****************************************************
end;

% Nsledujic prikazy se provedou je li uhel v II oblast - tj. v zkladnim
% materialu.

%********   O  B  L  A  S  T   (II)  ****************************(0,pi)
if ((uheltheta > 0) && (uheltheta < 180))
%******************** OBLAST I ***************** (0,-pi/2)
%jednicka za podtrzitkem znamena oblast na materialu
     AII =10^0* [ A11_2 , A12_2 ; A21_2 , A22_2]; %- jiz nemusime nasobit 10^6 - jiz z MAPLU jdou hodnoty v MPa - proto 10^0
%***
     LII = [ L11_2 , L12_2 ; L21_2 , L22_2];
%***           
  LphiII = [Lphi1_2 ; Lphi2_2] ;
%***
   mi1II = mi1_2;
   mi2II = mi2_2;
 MI_II=[ mi1_2 , 0  ;  0 , mi2_2 ] ;
   %*** vektor pro pomocn reseni
LphiSII =[LphiS1_2 ; LphiS2_2];	%vlastn vektor v_pom - odpovdajc pomocnmu een

if pomocnereseni==2
deltaS=delta; LphiSII=LphiII; %tento radek udela z pomocneho reseni singularni
end;

e=[(cos(theta)+mi1II*sin(theta))^(deltaS-1),0; 0,(cos(theta)+mi2II*sin(theta))^(deltaS-1)];
e2=[mi1II*(cos(theta)+mi1II*sin(theta))^(deltaS-1),0; 0,mi2II*(cos(theta)+mi2II*sin(theta))^(deltaS-1)];
e_p=[(cos(theta)+mi1II*sin(theta))^(deltaS),0; 0,(cos(theta)+mi2II*sin(theta))^(deltaS)];  %matice e definovana pro posuvy - je umocneno na deltaS

eCONJ= [(cos(theta)+conj(mi1II)*sin(theta))^(deltaS-1),0; 0,(cos(theta)+conj(mi2II)*sin(theta))^(deltaS-1)];
PHI=   delta  * [-mi1II*Lphi1_2 , Lphi1_2  ; -mi2II*Lphi2_2 , Lphi2_2 ];
PHI_S= deltaS * [-mi1II*LphiS1_2, LphiS1_2 ; -mi2II*LphiS2_2, LphiS2_2];
%***********

%*** Vpoet posuv pomocnho een****
posuvyII =  r^deltaS    * ( ( AII *  e_p * inv(LII) * LphiSII )  +  ( conj(AII)* conj(e_p) * inv(conj(LII))* conj(LphiSII) ) );

%*** Vpoet napt pomocnho een ****
SIGMAIIA= -r^(deltaS-1) *  ( LII * deltaS * (e * MI_II) * inv(LII) * LphiSII + conj(LII) * deltaS * conj(e * MI_II) * conj(inv(LII))* conj(LphiSII)) ;
SIGMAIIB=  r^(deltaS-1) *  ( LII * deltaS *  e          * inv(LII) * LphiSII + conj(LII) * deltaS * conj(e)         * conj(inv(LII))* conj(LphiSII)) ;

NAPETI_II(1,:)=SIGMAIIA;  NAPETI_II(2,:)=SIGMAIIB;  %zde se vytvori ze dvou vektoru jedna matice
NAPETI_II;   %vypise matici napeti v danem bode - na polomeru r a uhlu theta

 %ZDE ZUSTANOU POSUVY NAPETI V SS MAPLU
 UXpom= 10^0 * (posuvyII(1))    ; UYpom= 10^0 * (posuvyII(2));   %nasobime 10^3 abychom prevedli m na mm
 SXpom= 10^0* (NAPETI_II(1,1)) ; SYpom= 10^0* (NAPETI_II(2,2))  ;  SXYpom= 10^0 * (NAPETI_II(2,1));  %nasobime 10^-6 abychom prevedli Pa na MPa

 %*****************************************************
end;

% Nsledujic prikazy se provedou je li uhel v III oblast - tj. v horni
% casti povrchove vrstvy
%********   O  B  L  A  S  T   (III)  ***************************(pi,3/2pi)
if ((uheltheta >= 180) && (uheltheta <= 270))
%******************** OBLAST I ***************** (0,-pi/2)
%jednicka za podtrzitkem znamena oblast na materialu
     AIII =10^0* [ A11_3 , A12_3 ; A21_3 , A22_3]; %- jiz nemusime nasobit 10^6 - jiz z MAPLU jdou hodnoty v MPa - proto 10^0
%***
     LIII = [ L11_3 , L12_3 ; L21_3 , L22_3];
%***           
  LphiIII = [Lphi1_3 ; Lphi2_3] ;
%***
   mi1III = mi1_3;
   mi2III = mi2_3;
 MI_III=[ mi1_3 , 0  ;  0 , mi2_3 ] ;
   %*** vektor pro pomocn reseni
LphiSIII =[LphiS1_3 ; LphiS2_3];	%vlastn vektor v_pom - odpovdajc pomocnmu een

if pomocnereseni==2
deltaS=delta; LphiSIII=LphiIII; %tento radek udela z pomocneho reseni singularni
end;


e_old   = [(cos(theta)+mi1III*sin(theta))^(deltaS-1), 0 ; 0,(cos(theta)+mi2III*sin(theta))^(deltaS-1)];
e_old_p = [(cos(theta)+mi1III*sin(theta))^(deltaS)  , 0 ; 0,(cos(theta)+mi2III*sin(theta))^(deltaS)];  %matice e definovana pro posuvy - je umocneno na deltaS
PSI1=atan((imag(mi1III)*sin(theta))/(cos(theta)+ real(mi1III)*sin(theta)))+ pi;
PSI2=atan((imag(mi2III)*sin(theta))/(cos(theta)+ real(mi2III)*sin(theta)))+ pi;
R1=sqrt((cos(theta)+real(mi1III)*sin(theta))^2 + (imag(mi1III)*sin(theta))^2 );
R2=sqrt((cos(theta)+real(mi2III)*sin(theta))^2 + (imag(mi2III)*sin(theta))^2 );
e2   = [(R1 * exp(j*PSI1))^(deltaS-1), 0 ; 0,(R2 * exp(j*PSI2))^(deltaS-1)];
e2_p = [(R1 * exp(j*PSI1))^(deltaS)  , 0 ; 0,(R2 * exp(j*PSI2))^(deltaS)];
e   = [(R1^(deltaS-1) * exp((deltaS-1)*j*PSI1)), 0 ; 0,(R2^(deltaS-1) * exp((deltaS-1)*j*PSI2))];
e_p   = [(R1^(deltaS) * exp((deltaS)*j*PSI1)), 0 ; 0,(R2^(deltaS) * exp((deltaS)*j*PSI2))];

%eCONJ= [(cos(theta)+conj(mi1III)*sin(theta))^(deltaS-1),0; 0,(cos(theta)+conj(mi2III)*sin(theta))^(deltaS-1)];
PHI=   delta  * [-mi1III*Lphi1_3 , Lphi1_3  ; -mi2III*Lphi2_3 , Lphi2_3 ];
PHI_S= deltaS * [-mi1III*LphiS1_3, LphiS1_3 ; -mi2III*LphiS2_3, LphiS2_3];
%***********

%*** Vpoet posuv pomocnho een****
posuvyIII =  r^deltaS    * ( ( AIII *  e_p * inv(LIII) * LphiSIII )  +  ( conj(AIII)* conj(e_p) * inv(conj(LIII))* conj(LphiSIII) ) );

%*** Vpoet napt pomocnho een ****
SIGMAIIIA= -r^(deltaS-1) *  ( LIII * deltaS * (e * MI_III) * inv(LIII) * LphiSIII + conj(LIII) * deltaS * conj(e * MI_III) * conj(inv(LIII))* conj(LphiSIII)) ;
SIGMAIIIB=  r^(deltaS-1) *  ( LIII * deltaS *  e           * inv(LIII) * LphiSIII + conj(LIII) * deltaS * conj(e)          * conj(inv(LIII))* conj(LphiSIII)) ;

NAPETI_III(1,:)=SIGMAIIIA;  NAPETI_III(2,:)=SIGMAIIIB;  %zde se vytvori ze dvou vektoru jedna matice
NAPETI_III;   %vypise matici napeti v danem bode - na polomeru r a uhlu theta

 %ZDE ZUSTANOU POSUVY NAPETI V SS MAPLU
 UXpom= 10^0 * (posuvyIII(1))    ; UYpom= 10^0 * (posuvyIII(2));   %nasobime 10^3 abychom prevedli m na mm
 SXpom= 10^0* (NAPETI_III(1,1)) ; SYpom= 10^0* (NAPETI_III(2,2))  ;  SXYpom= 10^0 * (NAPETI_III(2,1));  %nasobime 10^-6 abychom prevedli Pa na MPa
 %*****************************************************
end;

